/*===========================================================================*/
/*   (BackEnd/jvm.scm)                                                       */
/*   Bigloo (4.0a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jan 24 17:03:30 CET 2013        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/4.0a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent BackEnd/jvm.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_jvmz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
		obj_t BgL_qnamez00;
		obj_t BgL_classesz00;
		obj_t BgL_currentzd2classzd2;
		obj_t BgL_declarationsz00;
		obj_t BgL_fieldsz00;
		obj_t BgL_methodsz00;
		obj_t BgL_currentzd2methodzd2;
		obj_t BgL_codez00;
		obj_t BgL_lightzd2funcallszd2;
		obj_t BgL_inlinez00;
	}             *BgL_jvmz00_bglt;


	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	BGL_IMPORT obj_t BGl_za2ppzd2widthza2zd2zz__ppz00;
	BGL_IMPORT bool_t BGl_makezd2directorieszd2zz__r4_ports_6_10_1z00(obj_t);
	BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
	BGL_IMPORT obj_t BGl_filezd2separatorzd2zz__osz00();
	BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
	extern obj_t BGl_za2passza2z00zzengine_paramz00;
	extern obj_t BGl_za2restzd2argsza2zd2zzengine_paramz00;
	static obj_t BGl_objectzd2initzd2zzbackend_jvmz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_za2ppzd2caseza2zd2zz__ppz00;
	static obj_t BGl_jasnamez00zzbackend_jvmz00(obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_dirnamez00zz__osz00(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	static obj_t BGl_addsuffixz00zzbackend_jvmz00(obj_t);
	BGL_IMPORT obj_t BGl_ppz00zz__ppz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2outputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zzbackend_jvmz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzbackend_jvmz00();
	static obj_t BGl_z62backendzd2linkzd2objects2148z62zzbackend_jvmz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_registerzd2backendz12zc0zzbackend_backendz00(obj_t, obj_t);
	BGL_IMPORT obj_t close_binary_port(obj_t);
	extern obj_t BGl_checkzd2jvmzd2inlinesz00zzsaw_jvm_inlinez00();
	static obj_t BGl_z62startzd2jvmzd2emissionz12z70zzbackend_jvmz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2bigloozd2mainz00zzbackend_c_mainz00();
	static obj_t BGl_z62zc3anonymousza32278ze3ze1zzbackend_jvmz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	BGL_IMPORT bool_t fexists(char *);
	extern obj_t BGl_za2mcozd2suffixza2zd2zzengine_paramz00;
	static BgL_jvmz00_bglt BGl_z62buildzd2jvmzd2backendz62zzbackend_jvmz00(obj_t);
	static obj_t BGl_zc3exitza32282ze3z83zzbackend_jvmz00(obj_t, obj_t);
	static obj_t BGl_startzd2jvmzd2emissionz12z12zzbackend_jvmz00();
	extern obj_t BGl_za2ozd2filesza2zd2zzengine_paramz00;
	extern obj_t BGl_za2jvmzd2directoryza2zd2zzengine_paramz00;
	static obj_t BGl_jvmzd2filenamezd2zzbackend_jvmz00(obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_jvmzd2classzd2sanszd2directoryzd2zzread_jvmz00(obj_t);
	extern obj_t BGl_stopzd2onzd2passz00zzengine_passz00(obj_t, obj_t);
	static obj_t BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00 = BUNSPEC;
	extern obj_t BGl_usezd2libraryz12zc0zzmodule_alibraryz00(obj_t);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
	extern obj_t BGl_za2mainza2z00zzmodule_modulez00;
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	extern obj_t BGl_za2destza2z00zzengine_paramz00;
	extern obj_t BGl_findzd2librarieszd2zzengine_linkz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzbackend_jvmz00 = BUNSPEC;
	extern obj_t BGl_za2srczd2filesza2zd2zzengine_paramz00;
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_toplevelzd2initzd2zzbackend_jvmz00();
	extern obj_t BGl_jvmzd2aszd2zzjas_asz00(obj_t, obj_t);
	static obj_t BGl_z62backendzd2cnstzd2tablezd2n2146zb0zzbackend_jvmz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzbackend_jvmz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_z62zc3anonymousza32243ze3ze1zzbackend_jvmz00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static BgL_jvmz00_bglt BGl_buildzd2jvmzd2backendz00zzbackend_jvmz00();
	static obj_t BGl_z62zc3anonymousza32245ze3ze1zzbackend_jvmz00(obj_t);
	extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	static obj_t BGl_makezd2tmpzd2filezd2namezd2zzbackend_jvmz00();
	BGL_IMPORT obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_basenamez00zz__osz00(obj_t);
	extern obj_t BGl_makezd2tmpzd2mainz00zzengine_linkz00(obj_t, bool_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32247ze3ze1zzbackend_jvmz00(obj_t);
	extern obj_t BGl_jvmz00zzbackend_jvm_classz00;
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	BGL_IMPORT obj_t BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_close_input_port(obj_t);
	static obj_t BGl_zc3exitza32322ze3z83zzbackend_jvmz00();
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_close_output_port(obj_t);
	extern obj_t BGl_jvmzd2ldzd2zzsaw_jvm_ldz00(obj_t);
	extern obj_t BGl_saw_jvmzd2compilezd2zzsaw_jvm_compilez00(BgL_jvmz00_bglt);
	static obj_t BGl_jvmzd2checkzd2packagez00zzbackend_jvmz00(obj_t, obj_t);
	static obj_t BGl_z62backendzd2compilezd2jvm2142z62zzbackend_jvmz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzbackend_jvmz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinit_setrcz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsaw_jvm_inlinez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsaw_jvm_ldz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsaw_jvm_compilez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzjas_peepz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzjas_asz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_c_mainz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_jvm_classz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_bvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_alibraryz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_compilerz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_linkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_compilerz00zzengine_compilerz00();
	static obj_t BGl_z62backendzd2subtypezf3zd2jvm2152z91zzbackend_jvmz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza32271ze3z83zzbackend_jvmz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_z62backendzd2linkzd2jvm2144z62zzbackend_jvmz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_suffixz00zz__osz00(obj_t);
	static obj_t BGl_jvmzd2dirnamezd2zzbackend_jvmz00(obj_t);
	extern obj_t BGl_loadzd2libraryzd2initz00zzmodule_alibraryz00();
	BGL_IMPORT obj_t string_to_symbol(char *);
	static obj_t BGl_cnstzd2initzd2zzbackend_jvmz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzbackend_jvmz00();
	extern obj_t BGl_compilerzd2readzd2zzread_readerz00(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzbackend_jvmz00();
	static obj_t BGl_z62backendzd2checkzd2inline2150z62zzbackend_jvmz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_prefixz00zz__osz00(obj_t);
	static obj_t BGl_zc3exitza32275ze3z83zzbackend_jvmz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t bgl_directoryp(char *);
	extern obj_t BGl_readzd2jfilezd2zzread_jvmz00();
	static obj_t BGl_emitz00zzbackend_jvmz00(obj_t, obj_t);
	extern obj_t BGl_iszd2subtypezf3z21zztype_typeofz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memberz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_jvmasdumpz00zzbackend_jvmz00(obj_t, obj_t);
	static obj_t __cnst[21];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_buildzd2jvmzd2backendzd2envzd2zzbackend_jvmz00,
		BgL_bgl_za762buildza7d2jvmza7d2600za7,
		BGl_z62buildzd2jvmzd2backendz62zzbackend_jvmz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2542z00zzbackend_jvmz00,
		BgL_bgl_string2542za700za7za7b2601za7, ".", 1);
	      DEFINE_STRING(BGl_string2543z00zzbackend_jvmz00,
		BgL_bgl_string2543za700za7za7b2602za7, "dummy", 5);
	      DEFINE_STRING(BGl_string2544z00zzbackend_jvmz00,
		BgL_bgl_string2544za700za7za7b2603za7, "jheap", 5);
	      DEFINE_STRING(BGl_string2545z00zzbackend_jvmz00,
		BgL_bgl_string2545za700za7za7b2604za7, "", 0);
	      DEFINE_STRING(BGl_string2546z00zzbackend_jvmz00,
		BgL_bgl_string2546za700za7za7b2605za7, "'.", 2);
	      DEFINE_STRING(BGl_string2547z00zzbackend_jvmz00,
		BgL_bgl_string2547za700za7za7b2606za7, "', class path is `", 18);
	      DEFINE_STRING(BGl_string2548z00zzbackend_jvmz00,
		BgL_bgl_string2548za700za7za7b2607za7, " is `", 5);
	      DEFINE_STRING(BGl_string2549z00zzbackend_jvmz00,
		BgL_bgl_string2549za700za7za7b2608za7, "Package name for module ", 24);
	      DEFINE_STRING(BGl_string2550z00zzbackend_jvmz00,
		BgL_bgl_string2550za700za7za7b2609za7,
		"Incompatible package name and class path.", 41);
	      DEFINE_STRING(BGl_string2551z00zzbackend_jvmz00,
		BgL_bgl_string2551za700za7za7b2610za7, ".jast", 5);
	      DEFINE_STRING(BGl_string2552z00zzbackend_jvmz00,
		BgL_bgl_string2552za700za7za7b2611za7, ".jas", 4);
	      DEFINE_STRING(BGl_string2553z00zzbackend_jvmz00,
		BgL_bgl_string2553za700za7za7b2612za7, ".class", 6);
	      DEFINE_STRING(BGl_string2554z00zzbackend_jvmz00,
		BgL_bgl_string2554za700za7za7b2613za7, "start-jvm-emission!", 19);
	      DEFINE_STRING(BGl_string2555z00zzbackend_jvmz00,
		BgL_bgl_string2555za700za7za7b2614za7,
		"Can't write dest file because directory doesn't exist", 53);
	extern obj_t BGl_backendzd2checkzd2inlineszd2envzd2zzbackend_backendz00;
	   
		 
		DEFINE_STRING(BGl_string2556z00zzbackend_jvmz00,
		BgL_bgl_string2556za700za7za7b2615za7, "JVMMAIN", 7);
	      DEFINE_STRING(BGl_string2557z00zzbackend_jvmz00,
		BgL_bgl_string2557za700za7za7b2616za7, ".bgl", 4);
	      DEFINE_STRING(BGl_string2559z00zzbackend_jvmz00,
		BgL_bgl_string2559za700za7za7b2617za7, "backend-compile", 15);
	      DEFINE_STRING(BGl_string2561z00zzbackend_jvmz00,
		BgL_bgl_string2561za700za7za7b2618za7, "backend-link", 12);
	      DEFINE_STRING(BGl_string2563z00zzbackend_jvmz00,
		BgL_bgl_string2563za700za7za7b2619za7, "backend-cnst-table-name", 23);
	      DEFINE_STRING(BGl_string2565z00zzbackend_jvmz00,
		BgL_bgl_string2565za700za7za7b2620za7, "backend-link-objects", 20);
	      DEFINE_STRING(BGl_string2567z00zzbackend_jvmz00,
		BgL_bgl_string2567za700za7za7b2621za7, "backend-check-inlines", 21);
	      DEFINE_STRING(BGl_string2569z00zzbackend_jvmz00,
		BgL_bgl_string2569za700za7za7b2622za7, "backend-subtype?", 16);
	      DEFINE_STRING(BGl_string2570z00zzbackend_jvmz00,
		BgL_bgl_string2570za700za7za7b2623za7, " -- ", 4);
	      DEFINE_STRING(BGl_string2571z00zzbackend_jvmz00,
		BgL_bgl_string2571za700za7za7b2624za7, "No source file found", 20);
	      DEFINE_STRING(BGl_string2572z00zzbackend_jvmz00,
		BgL_bgl_string2572za700za7za7b2625za7, "link", 4);
	      DEFINE_STRING(BGl_string2573z00zzbackend_jvmz00,
		BgL_bgl_string2573za700za7za7b2626za7, "\"", 1);
	      DEFINE_STRING(BGl_string2574z00zzbackend_jvmz00,
		BgL_bgl_string2574za700za7za7b2627za7, ")", 1);
	      DEFINE_STRING(BGl_string2575z00zzbackend_jvmz00,
		BgL_bgl_string2575za700za7za7b2628za7, " and ", 5);
	      DEFINE_STRING(BGl_string2576z00zzbackend_jvmz00,
		BgL_bgl_string2576za700za7za7b2629za7, "Redeclaration of the main (files ",
		33);
	      DEFINE_STRING(BGl_string2577z00zzbackend_jvmz00,
		BgL_bgl_string2577za700za7za7b2630za7, "Illegal file", 12);
	      DEFINE_STRING(BGl_string2578z00zzbackend_jvmz00,
		BgL_bgl_string2578za700za7za7b2631za7, "__cnst", 6);
	      DEFINE_STRING(BGl_string2579z00zzbackend_jvmz00,
		BgL_bgl_string2579za700za7za7b2632za7, "Jvm", 3);
	      DEFINE_STRING(BGl_string2580z00zzbackend_jvmz00,
		BgL_bgl_string2580za700za7za7b2633za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2581z00zzbackend_jvmz00,
		BgL_bgl_string2581za700za7za7b2634za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2582z00zzbackend_jvmz00,
		BgL_bgl_string2582za700za7za7b2635za7, "]", 1);
	      DEFINE_STRING(BGl_string2583z00zzbackend_jvmz00,
		BgL_bgl_string2583za700za7za7b2636za7, " qualified type name: ", 22);
	      DEFINE_STRING(BGl_string2584z00zzbackend_jvmz00,
		BgL_bgl_string2584za700za7za7b2637za7, "      [module: ", 15);
	      DEFINE_STRING(BGl_string2585z00zzbackend_jvmz00,
		BgL_bgl_string2585za700za7za7b2638za7, "a.class", 7);
	      DEFINE_STRING(BGl_string2589z00zzbackend_jvmz00,
		BgL_bgl_string2589za700za7za7b2639za7, "/", 1);
	      DEFINE_STRING(BGl_string2590z00zzbackend_jvmz00,
		BgL_bgl_string2590za700za7za7b2640za7, "/a.class", 8);
	      DEFINE_STRING(BGl_string2591z00zzbackend_jvmz00,
		BgL_bgl_string2591za700za7za7b2641za7, "\n", 1);
	      DEFINE_STRING(BGl_string2592z00zzbackend_jvmz00,
		BgL_bgl_string2592za700za7za7b2642za7, "        class: ", 15);
	      DEFINE_STRING(BGl_string2593z00zzbackend_jvmz00,
		BgL_bgl_string2593za700za7za7b2643za7, "jvm-dump", 8);
	      DEFINE_STRING(BGl_string2594z00zzbackend_jvmz00,
		BgL_bgl_string2594za700za7za7b2644za7, "Can't open file for output", 26);
	      DEFINE_STRING(BGl_string2595z00zzbackend_jvmz00,
		BgL_bgl_string2595za700za7za7b2645za7, "backend_jvm", 11);
	      DEFINE_STRING(BGl_string2596z00zzbackend_jvmz00,
		BgL_bgl_string2596za700za7za7b2646za7,
		"done cc (ld distrib) pass-started (start-jvm-emission!) main module library java.lang.Object object ld class jvmas jast lower unamed (jvm) (java) native bigloo-jvm jvm ",
		168);
	extern obj_t BGl_backendzd2cnstzd2tablezd2namezd2envz00zzbackend_backendz00;
	extern obj_t BGl_backendzd2subtypezf3zd2envzf3zzbackend_backendz00;
	extern obj_t BGl_backendzd2compilezd2envz00zzbackend_backendz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_startzd2jvmzd2emissionz12zd2envzc0zzbackend_jvmz00,
		BgL_bgl_za762startza7d2jvmza7d2647za7,
		BGl_z62startzd2jvmzd2emissionz12z70zzbackend_jvmz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_backendzd2linkzd2envz00zzbackend_backendz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2558z00zzbackend_jvmz00,
		BgL_bgl_za762backendza7d2com2648z00,
		BGl_z62backendzd2compilezd2jvm2142z62zzbackend_jvmz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2560z00zzbackend_jvmz00,
		BgL_bgl_za762backendza7d2lin2649z00,
		BGl_z62backendzd2linkzd2jvm2144z62zzbackend_jvmz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2562z00zzbackend_jvmz00,
		BgL_bgl_za762backendza7d2cns2650z00,
		BGl_z62backendzd2cnstzd2tablezd2n2146zb0zzbackend_jvmz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2564z00zzbackend_jvmz00,
		BgL_bgl_za762backendza7d2lin2651z00,
		BGl_z62backendzd2linkzd2objects2148z62zzbackend_jvmz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2566z00zzbackend_jvmz00,
		BgL_bgl_za762backendza7d2che2652z00,
		BGl_z62backendzd2checkzd2inline2150z62zzbackend_jvmz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2568z00zzbackend_jvmz00,
		BgL_bgl_za762backendza7d2sub2653z00,
		BGl_z62backendzd2subtypezf3zd2jvm2152z91zzbackend_jvmz00, 0L, BUNSPEC, 3);
	extern obj_t BGl_backendzd2linkzd2objectszd2envzd2zzbackend_backendz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2586z00zzbackend_jvmz00,
		BgL_bgl_za762za7c3anonymousza72654za7,
		BGl_z62zc3anonymousza32243ze3ze1zzbackend_jvmz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2587z00zzbackend_jvmz00,
		BgL_bgl_za762za7c3anonymousza72655za7,
		BGl_z62zc3anonymousza32245ze3ze1zzbackend_jvmz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2588z00zzbackend_jvmz00,
		BgL_bgl_za762za7c3anonymousza72656za7,
		BGl_z62zc3anonymousza32247ze3ze1zzbackend_jvmz00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzbackend_jvmz00(long
		BgL_checksumz00_3590, char *BgL_fromz00_3591)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzbackend_jvmz00))
				{
					BGl_requirezd2initializa7ationz75zzbackend_jvmz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzbackend_jvmz00();
					BGl_cnstzd2initzd2zzbackend_jvmz00();
					BGl_importedzd2moduleszd2initz00zzbackend_jvmz00();
					BGl_methodzd2initzd2zzbackend_jvmz00();
					BGl_toplevelzd2initzd2zzbackend_jvmz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"backend_jvm");
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"backend_jvm");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"backend_jvm");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "backend_jvm");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"backend_jvm");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"backend_jvm");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"backend_jvm");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			{	/* BackEnd/jvm.scm 15 */
				obj_t BgL_cportz00_3575;

				BgL_cportz00_3575 =
					bgl_open_input_string(BGl_string2596z00zzbackend_jvmz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3576;

					BgL_iz00_3576 = ((long) 20);
				BgL_loopz00_3577:
					if ((BgL_iz00_3576 == ((long) -1)))
						{	/* BackEnd/jvm.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* BackEnd/jvm.scm 15 */
							{	/* BackEnd/jvm.scm 15 */
								obj_t BgL_arg2598z00_3579;

								{	/* BackEnd/jvm.scm 15 */

									{	/* BackEnd/jvm.scm 15 */
										obj_t BgL_locationz00_3581;

										BgL_locationz00_3581 = BBOOL(((bool_t) 0));
										{	/* BackEnd/jvm.scm 15 */

											BgL_arg2598z00_3579 =
												BGl_readz00zz__readerz00(BgL_cportz00_3575,
												BgL_locationz00_3581);
										}
									}
								}
								{	/* BackEnd/jvm.scm 15 */
									int BgL_auxz00_3619;

									BgL_auxz00_3619 = (int) (BgL_iz00_3576);
									CNST_TABLE_SET(BgL_auxz00_3619, BgL_arg2598z00_3579);
							}}
							{	/* BackEnd/jvm.scm 15 */
								int BgL_auxz00_3582;

								BgL_auxz00_3582 = (int) ((BgL_iz00_3576 - ((long) 1)));
								{
									long BgL_iz00_3624;

									BgL_iz00_3624 = (long) (BgL_auxz00_3582);
									BgL_iz00_3576 = BgL_iz00_3624;
									goto BgL_loopz00_3577;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			BGl_registerzd2backendz12zc0zzbackend_backendz00(CNST_TABLE_REF(((long)
						0)), BGl_buildzd2jvmzd2backendzd2envzd2zzbackend_jvmz00);
			BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00 =
				BGl_string2542z00zzbackend_jvmz00;
			return BUNSPEC;
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzbackend_jvmz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_1768;

				BgL_headz00_1768 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_1769;
					obj_t BgL_tailz00_1770;

					BgL_prevz00_1769 = BgL_headz00_1768;
					BgL_tailz00_1770 = BgL_l1z00_1;
				BgL_loopz00_1771:
					if (PAIRP(BgL_tailz00_1770))
						{
							obj_t BgL_newzd2prevzd2_1773;

							BgL_newzd2prevzd2_1773 =
								MAKE_PAIR(CAR(BgL_tailz00_1770), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_1769, BgL_newzd2prevzd2_1773);
							{
								obj_t BgL_tailz00_3635;
								obj_t BgL_prevz00_3634;

								BgL_prevz00_3634 = BgL_newzd2prevzd2_1773;
								BgL_tailz00_3635 = CDR(BgL_tailz00_1770);
								BgL_tailz00_1770 = BgL_tailz00_3635;
								BgL_prevz00_1769 = BgL_prevz00_3634;
								goto BgL_loopz00_1771;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_1768);
				}
			}
		}
	}



/* build-jvm-backend */
	BgL_jvmz00_bglt BGl_buildzd2jvmzd2backendz00zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 51 */
			{	/* BackEnd/jvm.scm 52 */
				BgL_jvmz00_bglt BgL_new1109z00_1776;

				{	/* BackEnd/jvm.scm 52 */
					BgL_jvmz00_bglt BgL_new1108z00_1778;

					BgL_new1108z00_1778 =
						((BgL_jvmz00_bglt) BREF(GC_MALLOC(sizeof(struct BgL_jvmz00_bgl))));
					{	/* BackEnd/jvm.scm 52 */
						long BgL_arg2157z00_1779;

						{	/* BackEnd/jvm.scm 52 */
							long BgL_res2463z00_3228;

							BgL_res2463z00_3228 =
								BGL_CLASS_INDEX(BGl_jvmz00zzbackend_jvm_classz00);
							BgL_arg2157z00_1779 = BgL_res2463z00_3228;
						}
						{	/* BackEnd/jvm.scm 52 */
							BgL_objectz00_bglt BgL_objz00_3229;

							BgL_objz00_3229 = ((BgL_objectz00_bglt) BgL_new1108z00_1778);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_3229, BgL_arg2157z00_1779);
					}}
					{	/* BackEnd/jvm.scm 52 */
						BgL_objectz00_bglt BgL_auxz00_3642;

						BgL_auxz00_3642 = ((BgL_objectz00_bglt) BgL_new1108z00_1778);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_3642, BFALSE);
					}
					BgL_new1109z00_1776 = BgL_new1108z00_1778;
				}
				((((BgL_backendz00_bglt) CREF(
								((BgL_backendz00_bglt) BgL_new1109z00_1776)))->
						BgL_languagez00) = ((obj_t) CNST_TABLE_REF(((long) 0))), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_srfi0z00) =
					((obj_t) CNST_TABLE_REF(((long) 1))), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_namez00) =
					((obj_t) BGl_string2543z00zzbackend_jvmz00), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_externzd2variableszd2) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_externzd2functionszd2) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_externzd2typeszd2) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_variablesz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_functionsz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_typesz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_typedz00) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_heapzd2suffixzd2) =
					((obj_t) BGl_string2544z00zzbackend_jvmz00), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_heapzd2compatiblezd2) =
					((obj_t) CNST_TABLE_REF(((long) 2))), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_callccz00) =
					((bool_t) ((bool_t) 1)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_qualifiedzd2typeszd2) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_effectzb2zb2) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_removezd2emptyzd2letz00) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_foreignzd2closurezd2) =
					((bool_t) ((bool_t) 1)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_typedzd2eqzd2) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_tracezd2supportzd2) =
					((bool_t) ((bool_t) 1)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_foreignzd2clausezd2supportz00) =
					((obj_t) CNST_TABLE_REF(((long) 3))), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_debugzd2supportzd2) =
					((obj_t) CNST_TABLE_REF(((long) 4))), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_pragmazd2supportzd2) =
					((bool_t) ((bool_t) 1)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_tvectorzd2descrzd2supportz00) =
					((bool_t) ((bool_t) 1)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_requirezd2tailczd2) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_registersz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_pregistersz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_boundzd2checkzd2) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_typezd2checkzd2) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_backendz00_bglt) CREF(((BgL_backendz00_bglt)
									BgL_new1109z00_1776)))->BgL_typedzd2funcallzd2) =
					((bool_t) ((bool_t) 1)), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_qnamez00) =
					((obj_t) CNST_TABLE_REF(((long) 5))), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_classesz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->
						BgL_currentzd2classzd2) = ((obj_t) BFALSE), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_declarationsz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_fieldsz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_methodsz00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->
						BgL_currentzd2methodzd2) = ((obj_t) BFALSE), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_codez00) =
					((obj_t) BNIL), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->
						BgL_lightzd2funcallszd2) = ((obj_t) BNIL), BUNSPEC);
				((((BgL_jvmz00_bglt) CREF(BgL_new1109z00_1776))->BgL_inlinez00) =
					((obj_t) BTRUE), BUNSPEC);
				{	/* BackEnd/jvm.scm 52 */
					obj_t BgL_fun2156z00_1777;

					BgL_fun2156z00_1777 =
						BGl_classzd2constructorzd2zz__objectz00
						(BGl_jvmz00zzbackend_jvm_classz00);
					PROCEDURE_ENTRY(BgL_fun2156z00_1777) (BgL_fun2156z00_1777,
						((obj_t) BgL_new1109z00_1776), BEOA);
				}
				return BgL_new1109z00_1776;
			}
		}
	}



/* &build-jvm-backend */
	BgL_jvmz00_bglt BGl_z62buildzd2jvmzd2backendz62zzbackend_jvmz00(obj_t
		BgL_envz00_3510)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 51 */
			return BGl_buildzd2jvmzd2backendz00zzbackend_jvmz00();
		}
	}



/* jvm-check-package */
	obj_t BGl_jvmzd2checkzd2packagez00zzbackend_jvmz00(obj_t BgL_modulez00_4,
		obj_t BgL_pathz00_5)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 126 */
			{
				obj_t BgL_basez00_1796;
				obj_t BgL_pathz00_1797;

				{	/* BackEnd/jvm.scm 143 */
					obj_t BgL_qtypez00_1781;

					BgL_qtypez00_1781 =
						BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(BgL_modulez00_4);
					{	/* BackEnd/jvm.scm 143 */
						obj_t BgL_basez00_1782;

						{	/* BackEnd/jvm.scm 144 */
							obj_t BgL_prez00_1793;

							BgL_prez00_1793 = BGl_prefixz00zz__osz00(BgL_qtypez00_1781);
							if (bigloo_strcmp(BgL_prez00_1793,
									BGl_string2545z00zzbackend_jvmz00))
								{	/* BackEnd/jvm.scm 146 */
									BgL_basez00_1782 = BGl_string2542z00zzbackend_jvmz00;
								}
							else
								{	/* BackEnd/jvm.scm 146 */
									if (bigloo_strcmp(BgL_prez00_1793, BgL_qtypez00_1781))
										{	/* BackEnd/jvm.scm 148 */
											BgL_basez00_1782 = BGl_string2542z00zzbackend_jvmz00;
										}
									else
										{	/* BackEnd/jvm.scm 148 */
											BgL_basez00_1782 = BgL_prez00_1793;
										}
								}
						}
						{	/* BackEnd/jvm.scm 144 */

							{	/* BackEnd/jvm.scm 152 */
								bool_t BgL_testz00_3732;

								BgL_basez00_1796 =
									BGl_jvmzd2filenamezd2zzbackend_jvmz00(BgL_basez00_1782);
								BgL_pathz00_1797 = BgL_pathz00_5;
								{	/* BackEnd/jvm.scm 128 */
									long BgL_lbasez00_1799;
									long BgL_lpathz00_1800;

									BgL_lbasez00_1799 = STRING_LENGTH(BgL_basez00_1796);
									BgL_lpathz00_1800 = STRING_LENGTH(BgL_pathz00_1797);
									if ((BgL_lpathz00_1800 < BgL_lbasez00_1799))
										{	/* BackEnd/jvm.scm 130 */
											BgL_testz00_3732 = ((bool_t) 0);
										}
									else
										{
											long BgL_rpathz00_1805;
											long BgL_rbasez00_1806;

											BgL_rpathz00_1805 = (BgL_lpathz00_1800 - ((long) 1));
											BgL_rbasez00_1806 = (BgL_lbasez00_1799 - ((long) 1));
										BgL_zc3anonymousza32174ze3z83_1807:
											if ((BgL_rbasez00_1806 == ((long) -1)))
												{	/* BackEnd/jvm.scm 134 */
													BgL_testz00_3732 = ((bool_t) 1);
												}
											else
												{	/* BackEnd/jvm.scm 136 */
													unsigned char BgL_cbasez00_1809;
													unsigned char BgL_cpathz00_1810;

													BgL_cbasez00_1809 =
														STRING_REF(BgL_basez00_1796, BgL_rbasez00_1806);
													BgL_cpathz00_1810 =
														STRING_REF(BgL_pathz00_1797, BgL_rpathz00_1805);
													{	/* BackEnd/jvm.scm 138 */
														bool_t BgL_testz00_3741;

														if ((BgL_cbasez00_1809 == BgL_cpathz00_1810))
															{	/* BackEnd/jvm.scm 138 */
																BgL_testz00_3741 = ((bool_t) 1);
															}
														else
															{	/* BackEnd/jvm.scm 138 */
																if (
																	(BgL_cpathz00_1810 == ((unsigned char) '/')))
																	{	/* BackEnd/jvm.scm 139 */
																		BgL_testz00_3741 =
																			(BgL_cbasez00_1809 ==
																			((unsigned char) '.'));
																	}
																else
																	{	/* BackEnd/jvm.scm 139 */
																		BgL_testz00_3741 = ((bool_t) 0);
																	}
															}
														if (BgL_testz00_3741)
															{
																long BgL_rbasez00_3749;
																long BgL_rpathz00_3747;

																BgL_rpathz00_3747 =
																	(BgL_rpathz00_1805 - ((long) 1));
																BgL_rbasez00_3749 =
																	(BgL_rbasez00_1806 - ((long) 1));
																BgL_rbasez00_1806 = BgL_rbasez00_3749;
																BgL_rpathz00_1805 = BgL_rpathz00_3747;
																goto BgL_zc3anonymousza32174ze3z83_1807;
															}
														else
															{	/* BackEnd/jvm.scm 138 */
																BgL_testz00_3732 = ((bool_t) 0);
															}
													}
												}
										}
								}
								if (BgL_testz00_3732)
									{	/* BackEnd/jvm.scm 152 */
										return BFALSE;
									}
								else
									{	/* BackEnd/jvm.scm 153 */
										obj_t BgL_list2159z00_1784;

										{	/* BackEnd/jvm.scm 153 */
											obj_t BgL_arg2160z00_1785;

											{	/* BackEnd/jvm.scm 153 */
												obj_t BgL_arg2161z00_1786;

												{	/* BackEnd/jvm.scm 153 */
													obj_t BgL_arg2162z00_1787;

													{	/* BackEnd/jvm.scm 153 */
														obj_t BgL_arg2163z00_1788;

														{	/* BackEnd/jvm.scm 153 */
															obj_t BgL_arg2165z00_1789;

															{	/* BackEnd/jvm.scm 153 */
																obj_t BgL_arg2166z00_1790;

																{	/* BackEnd/jvm.scm 153 */
																	obj_t BgL_arg2168z00_1791;

																	BgL_arg2168z00_1791 =
																		MAKE_PAIR(BGl_string2546z00zzbackend_jvmz00,
																		BNIL);
																	BgL_arg2166z00_1790 =
																		MAKE_PAIR(BgL_pathz00_5,
																		BgL_arg2168z00_1791);
																}
																BgL_arg2165z00_1789 =
																	MAKE_PAIR(BGl_string2547z00zzbackend_jvmz00,
																	BgL_arg2166z00_1790);
															}
															BgL_arg2163z00_1788 =
																MAKE_PAIR(BgL_basez00_1782,
																BgL_arg2165z00_1789);
														}
														BgL_arg2162z00_1787 =
															MAKE_PAIR(BGl_string2548z00zzbackend_jvmz00,
															BgL_arg2163z00_1788);
													}
													BgL_arg2161z00_1786 =
														MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00,
														BgL_arg2162z00_1787);
												}
												BgL_arg2160z00_1785 =
													MAKE_PAIR(BGl_string2549z00zzbackend_jvmz00,
													BgL_arg2161z00_1786);
											}
											BgL_list2159z00_1784 =
												MAKE_PAIR(BGl_string2550z00zzbackend_jvmz00,
												BgL_arg2160z00_1785);
										}
										return BGl_warningz00zz__errorz00(BgL_list2159z00_1784);
									}
							}
						}
					}
				}
			}
		}
	}



/* jvmasdump */
	obj_t BGl_jvmasdumpz00zzbackend_jvmz00(obj_t BgL_classfilez00_6,
		obj_t BgL_portz00_7)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 159 */
			{	/* BackEnd/jvm.scm 160 */
				obj_t BgL_owz00_1818;
				obj_t BgL_ocz00_1819;

				BgL_owz00_1818 = BGl_za2ppzd2widthza2zd2zz__ppz00;
				BgL_ocz00_1819 = BGl_za2ppzd2caseza2zd2zz__ppz00;
				BGl_za2ppzd2widthza2zd2zz__ppz00 = BINT(((long) 10240));
				BGl_za2ppzd2caseza2zd2zz__ppz00 = CNST_TABLE_REF(((long) 6));
				{	/* BackEnd/jvm.scm 163 */
					obj_t BgL_list2180z00_1820;

					BgL_list2180z00_1820 = MAKE_PAIR(BgL_portz00_7, BNIL);
					BGl_ppz00zz__ppz00(BgL_classfilez00_6, BgL_list2180z00_1820);
				}
				BGl_za2ppzd2caseza2zd2zz__ppz00 = BgL_ocz00_1819;
				return (BGl_za2ppzd2widthza2zd2zz__ppz00 = BgL_owz00_1818, BUNSPEC);
			}
		}
	}



/* addsuffix */
	obj_t BGl_addsuffixz00zzbackend_jvmz00(obj_t BgL_namez00_8)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 167 */
			{	/* BackEnd/jvm.scm 169 */
				obj_t BgL_arg2182z00_1821;

				{	/* BackEnd/jvm.scm 169 */
					obj_t BgL_casezd2valuezd2_1822;

					BgL_casezd2valuezd2_1822 = BGl_za2passza2z00zzengine_paramz00;
					if ((BgL_casezd2valuezd2_1822 == CNST_TABLE_REF(((long) 7))))
						{	/* BackEnd/jvm.scm 169 */
							BgL_arg2182z00_1821 = BGl_string2551z00zzbackend_jvmz00;
						}
					else
						{	/* BackEnd/jvm.scm 169 */
							if ((BgL_casezd2valuezd2_1822 == CNST_TABLE_REF(((long) 8))))
								{	/* BackEnd/jvm.scm 169 */
									BgL_arg2182z00_1821 = BGl_string2552z00zzbackend_jvmz00;
								}
							else
								{	/* BackEnd/jvm.scm 169 */
									BgL_arg2182z00_1821 = BGl_string2553z00zzbackend_jvmz00;
								}
						}
				}
				return string_append(BgL_namez00_8, BgL_arg2182z00_1821);
			}
		}
	}



/* jasname */
	obj_t BGl_jasnamez00zzbackend_jvmz00(obj_t BgL_cfz00_9)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 177 */
			if (PAIRP(BgL_cfz00_9))
				{	/* BackEnd/jvm.scm 178 */
					obj_t BgL_carzd2139zd2_1829;

					BgL_carzd2139zd2_1829 = CAR(BgL_cfz00_9);
					if (PAIRP(BgL_carzd2139zd2_1829))
						{	/* BackEnd/jvm.scm 178 */
							obj_t BgL_cdrzd2143zd2_1831;

							BgL_cdrzd2143zd2_1831 = CDR(BgL_carzd2139zd2_1829);
							if ((CAR(BgL_carzd2139zd2_1829) == CNST_TABLE_REF(((long) 9))))
								{	/* BackEnd/jvm.scm 178 */
									if (PAIRP(BgL_cdrzd2143zd2_1831))
										{	/* BackEnd/jvm.scm 178 */
											if (NULLP(CDR(BgL_cdrzd2143zd2_1831)))
												{	/* BackEnd/jvm.scm 178 */
													obj_t BgL_arg2190z00_1835;

													BgL_arg2190z00_1835 = CAR(BgL_cdrzd2143zd2_1831);
													{	/* BackEnd/jvm.scm 180 */
														obj_t BgL_arg2193z00_3289;

														{	/* BackEnd/jvm.scm 180 */
															obj_t BgL_res2483z00_3292;

															{	/* BackEnd/jvm.scm 180 */
																obj_t BgL_symbolz00_3290;

																BgL_symbolz00_3290 = BgL_arg2190z00_1835;
																{	/* Ieee/symbol.scm 135 */
																	obj_t BgL_arg1321z00_3291;

																	BgL_arg1321z00_3291 =
																		SYMBOL_TO_STRING(BgL_symbolz00_3290);
																	BgL_res2483z00_3292 =
																		BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																		(BgL_arg1321z00_3291);
																}
															}
															BgL_arg2193z00_3289 = BgL_res2483z00_3292;
														}
														return
															BGl_addsuffixz00zzbackend_jvmz00
															(BgL_arg2193z00_3289);
													}
												}
											else
												{	/* BackEnd/jvm.scm 178 */
													return BFALSE;
												}
										}
									else
										{	/* BackEnd/jvm.scm 178 */
											return BFALSE;
										}
								}
							else
								{	/* BackEnd/jvm.scm 178 */
									return BFALSE;
								}
						}
					else
						{	/* BackEnd/jvm.scm 178 */
							return BFALSE;
						}
				}
			else
				{	/* BackEnd/jvm.scm 178 */
					return BFALSE;
				}
		}
	}



/* jvm-filename */
	obj_t BGl_jvmzd2filenamezd2zzbackend_jvmz00(obj_t BgL_namez00_10)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 185 */
			if (STRINGP(BGl_za2jvmzd2directoryza2zd2zzengine_paramz00))
				{	/* BackEnd/jvm.scm 186 */
					if (bigloo_strcmp(BgL_namez00_10, BGl_string2542z00zzbackend_jvmz00))
						{	/* BackEnd/jvm.scm 187 */
							return BGl_za2jvmzd2directoryza2zd2zzengine_paramz00;
						}
					else
						{	/* BackEnd/jvm.scm 187 */
							return
								BGl_makezd2filezd2namez00zz__osz00
								(BGl_za2jvmzd2directoryza2zd2zzengine_paramz00, BgL_namez00_10);
						}
				}
			else
				{	/* BackEnd/jvm.scm 186 */
					return BgL_namez00_10;
				}
		}
	}



/* jvm-dirname */
	obj_t BGl_jvmzd2dirnamezd2zzbackend_jvmz00(obj_t BgL_filez00_11)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 195 */
			{	/* BackEnd/jvm.scm 196 */
				obj_t BgL_dfilez00_1841;

				BgL_dfilez00_1841 = BGl_dirnamez00zz__osz00(BgL_filez00_11);
				{	/* BackEnd/jvm.scm 196 */
					obj_t BgL_dirz00_1842;

					BgL_dirz00_1842 =
						BGl_jvmzd2filenamezd2zzbackend_jvmz00(BgL_dfilez00_1841);
					{	/* BackEnd/jvm.scm 197 */

						{	/* BackEnd/jvm.scm 198 */
							bool_t BgL_testz00_3800;

							if (bigloo_strcmp(BgL_dfilez00_1841,
									BGl_string2545z00zzbackend_jvmz00))
								{	/* BackEnd/jvm.scm 198 */
									BgL_testz00_3800 = ((bool_t) 0);
								}
							else
								{	/* BackEnd/jvm.scm 198 */
									if (bgl_directoryp(BSTRING_TO_STRING(BgL_dfilez00_1841)))
										{	/* BackEnd/jvm.scm 199 */
											BgL_testz00_3800 = ((bool_t) 0);
										}
									else
										{	/* BackEnd/jvm.scm 199 */
											if (fexists(BSTRING_TO_STRING(BgL_dfilez00_1841)))
												{	/* BackEnd/jvm.scm 200 */
													BgL_testz00_3800 = ((bool_t) 0);
												}
											else
												{	/* BackEnd/jvm.scm 201 */
													bool_t BgL__ortest_1131z00_1847;

													if (STRINGP
														(BGl_za2jvmzd2directoryza2zd2zzengine_paramz00))
														{	/* BackEnd/jvm.scm 201 */
															BgL__ortest_1131z00_1847 = ((bool_t) 0);
														}
													else
														{	/* BackEnd/jvm.scm 201 */
															BgL__ortest_1131z00_1847 = ((bool_t) 1);
														}
													if (BgL__ortest_1131z00_1847)
														{	/* BackEnd/jvm.scm 201 */
															BgL_testz00_3800 = BgL__ortest_1131z00_1847;
														}
													else
														{	/* BackEnd/jvm.scm 201 */
															BgL_testz00_3800 =
																bgl_directoryp(BSTRING_TO_STRING
																(BGl_za2jvmzd2directoryza2zd2zzengine_paramz00));
														}
												}
										}
								}
							if (BgL_testz00_3800)
								{	/* BackEnd/jvm.scm 198 */
									BGl_makezd2directorieszd2zz__r4_ports_6_10_1z00
										(BgL_dirz00_1842);
								}
							else
								{	/* BackEnd/jvm.scm 198 */
									((bool_t) 0);
								}
						}
						return BgL_dirz00_1842;
					}
				}
			}
		}
	}



/* start-jvm-emission! */
	obj_t BGl_startzd2jvmzd2emissionz12z12zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 210 */
			if (STRINGP(BGl_za2destza2z00zzengine_paramz00))
				{	/* BackEnd/jvm.scm 213 */
					obj_t BgL_dnamez00_1850;

					BgL_dnamez00_1850 =
						BGl_dirnamez00zz__osz00(BGl_za2destza2z00zzengine_paramz00);
					if (bigloo_strcmp(BgL_dnamez00_1850,
							BGl_string2545z00zzbackend_jvmz00))
						{	/* BackEnd/jvm.scm 214 */
							BFALSE;
						}
					else
						{	/* BackEnd/jvm.scm 214 */
							BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00 =
								BGl_jvmzd2dirnamezd2zzbackend_jvmz00
								(BGl_za2destza2z00zzengine_paramz00);
						}
				}
			else
				{	/* BackEnd/jvm.scm 212 */
					if (
						(BGl_za2passza2z00zzengine_paramz00 == CNST_TABLE_REF(((long) 10))))
						{	/* BackEnd/jvm.scm 216 */
							if (PAIRP(BGl_za2srczd2filesza2zd2zzengine_paramz00))
								{	/* BackEnd/jvm.scm 217 */
									BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00 =
										BGl_jvmzd2dirnamezd2zzbackend_jvmz00(CAR
										(BGl_za2srczd2filesza2zd2zzengine_paramz00));
								}
							else
								{	/* BackEnd/jvm.scm 217 */
									BFALSE;
								}
						}
					else
						{	/* BackEnd/jvm.scm 216 */
							BFALSE;
						}
				}
			{	/* BackEnd/jvm.scm 219 */
				bool_t BgL_testz00_3828;

				if (fexists(BSTRING_TO_STRING
						(BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00)))
					{	/* BackEnd/jvm.scm 219 */
						BgL_testz00_3828 =
							bgl_directoryp(BSTRING_TO_STRING
							(BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00));
					}
				else
					{	/* BackEnd/jvm.scm 219 */
						BgL_testz00_3828 = ((bool_t) 0);
					}
				if (BgL_testz00_3828)
					{	/* BackEnd/jvm.scm 219 */
						return BTRUE;
					}
				else
					{	/* BackEnd/jvm.scm 219 */
						return
							BGl_errorz00zz__errorz00(BGl_string2554z00zzbackend_jvmz00,
							BGl_string2555z00zzbackend_jvmz00,
							BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00);
					}
			}
		}
	}



/* &start-jvm-emission! */
	obj_t BGl_z62startzd2jvmzd2emissionz12z70zzbackend_jvmz00(obj_t
		BgL_envz00_3511)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 210 */
			return BGl_startzd2jvmzd2emissionz12z12zzbackend_jvmz00();
		}
	}



/* make-tmp-file-name */
	obj_t BGl_makezd2tmpzd2filezd2namezd2zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 254 */
			return
				string_append(BGl_string2556z00zzbackend_jvmz00,
				BGl_string2557z00zzbackend_jvmz00);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_backendzd2compilezd2envz00zzbackend_backendz00,
				BGl_jvmz00zzbackend_jvm_classz00, BGl_proc2558z00zzbackend_jvmz00,
				BGl_string2559z00zzbackend_jvmz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_backendzd2linkzd2envz00zzbackend_backendz00,
				BGl_jvmz00zzbackend_jvm_classz00, BGl_proc2560z00zzbackend_jvmz00,
				BGl_string2561z00zzbackend_jvmz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_backendzd2cnstzd2tablezd2namezd2envz00zzbackend_backendz00,
				BGl_jvmz00zzbackend_jvm_classz00, BGl_proc2562z00zzbackend_jvmz00,
				BGl_string2563z00zzbackend_jvmz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_backendzd2linkzd2objectszd2envzd2zzbackend_backendz00,
				BGl_jvmz00zzbackend_jvm_classz00, BGl_proc2564z00zzbackend_jvmz00,
				BGl_string2565z00zzbackend_jvmz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_backendzd2checkzd2inlineszd2envzd2zzbackend_backendz00,
				BGl_jvmz00zzbackend_jvm_classz00, BGl_proc2566z00zzbackend_jvmz00,
				BGl_string2567z00zzbackend_jvmz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_backendzd2subtypezf3zd2envzf3zzbackend_backendz00,
				BGl_jvmz00zzbackend_jvm_classz00, BGl_proc2568z00zzbackend_jvmz00,
				BGl_string2569z00zzbackend_jvmz00);
		}
	}



/* &backend-subtype?-jvm2152 */
	obj_t BGl_z62backendzd2subtypezf3zd2jvm2152z91zzbackend_jvmz00(obj_t
		BgL_envz00_3522, obj_t BgL_bz00_3523, obj_t BgL_t1z00_3524,
		obj_t BgL_t2z00_3525)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 384 */
			{
				BgL_jvmz00_bglt BgL_bz00_2155;
				obj_t BgL_t1z00_2156;
				obj_t BgL_t2z00_2157;

				BgL_bz00_2155 = ((BgL_jvmz00_bglt) BgL_bz00_3523);
				BgL_t1z00_2156 = BgL_t1z00_3524;
				BgL_t2z00_2157 = BgL_t2z00_3525;
				{	/* BackEnd/jvm.scm 385 */
					bool_t BgL__ortest_1138z00_2160;

					BgL__ortest_1138z00_2160 = (BgL_t1z00_2156 == BgL_t2z00_2157);
					if (BgL__ortest_1138z00_2160)
						{	/* BackEnd/jvm.scm 385 */
							return BBOOL(BgL__ortest_1138z00_2160);
						}
					else
						{	/* BackEnd/jvm.scm 386 */
							bool_t BgL__ortest_1139z00_2161;

							BgL__ortest_1139z00_2161 =
								(
								(((BgL_typez00_bglt) CREF(
											((BgL_typez00_bglt) BgL_t1z00_2156)))->BgL_idz00) ==
								(((BgL_typez00_bglt) CREF(
											((BgL_typez00_bglt) BgL_t2z00_2157)))->BgL_idz00));
							if (BgL__ortest_1139z00_2161)
								{	/* BackEnd/jvm.scm 386 */
									return BBOOL(BgL__ortest_1139z00_2161);
								}
							else
								{	/* BackEnd/jvm.scm 387 */
									bool_t BgL__ortest_1140z00_2162;

									if (BGl_isazf3zf3zz__objectz00(BgL_t1z00_2156,
											BGl_tclassz00zzobject_classz00))
										{	/* BackEnd/jvm.scm 387 */
											BgL__ortest_1140z00_2162 =
												(
												(((BgL_typez00_bglt) CREF(
															((BgL_typez00_bglt) BgL_t2z00_2157)))->
													BgL_idz00) == CNST_TABLE_REF(((long) 11)));
										}
									else
										{	/* BackEnd/jvm.scm 387 */
											BgL__ortest_1140z00_2162 = ((bool_t) 0);
										}
									if (BgL__ortest_1140z00_2162)
										{	/* BackEnd/jvm.scm 387 */
											return BBOOL(BgL__ortest_1140z00_2162);
										}
									else
										{	/* BackEnd/jvm.scm 388 */
											bool_t BgL__ortest_1141z00_2163;

											BgL__ortest_1141z00_2163 =
												(
												(((BgL_typez00_bglt) CREF(
															((BgL_typez00_bglt) BgL_t2z00_2157)))->
													BgL_namez00) == CNST_TABLE_REF(((long) 12)));
											if (BgL__ortest_1141z00_2163)
												{	/* BackEnd/jvm.scm 388 */
													return BBOOL(BgL__ortest_1141z00_2163);
												}
											else
												{	/* BackEnd/jvm.scm 389 */
													bool_t BgL__ortest_1142z00_2164;

													BgL__ortest_1142z00_2164 =
														(
														(((BgL_typez00_bglt) CREF(
																	((BgL_typez00_bglt) BgL_t1z00_2156)))->
															BgL_namez00) ==
														(((BgL_typez00_bglt) CREF(((BgL_typez00_bglt)
																		BgL_t2z00_2157)))->BgL_namez00));
													if (BgL__ortest_1142z00_2164)
														{	/* BackEnd/jvm.scm 389 */
															return BBOOL(BgL__ortest_1142z00_2164);
														}
													else
														{	/* BackEnd/jvm.scm 390 */
															obj_t BgL__ortest_1143z00_2165;

															BgL__ortest_1143z00_2165 =
																BGl_iszd2subtypezf3z21zztype_typeofz00
																(BgL_t1z00_2156, BgL_t2z00_2157);
															if (CBOOL(BgL__ortest_1143z00_2165))
																{	/* BackEnd/jvm.scm 390 */
																	return BgL__ortest_1143z00_2165;
																}
															else
																{	/* BackEnd/jvm.scm 390 */
																	return
																		BBOOL(BGl_subzd2typezf3z21zztype_envz00(
																			((BgL_typez00_bglt) BgL_t1z00_2156),
																			((BgL_typez00_bglt) BgL_t2z00_2157)));
																}
														}
												}
										}
								}
						}
				}
			}
		}
	}



/* &backend-check-inline2150 */
	obj_t BGl_z62backendzd2checkzd2inline2150z62zzbackend_jvmz00(obj_t
		BgL_envz00_3526, obj_t BgL_mez00_3527)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 378 */
			{
				BgL_jvmz00_bglt BgL_mez00_2151;

				BgL_mez00_2151 = ((BgL_jvmz00_bglt) BgL_mez00_3527);
				if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
					{	/* BackEnd/jvm.scm 379 */
						return BFALSE;
					}
				else
					{	/* BackEnd/jvm.scm 379 */
						return BGl_checkzd2jvmzd2inlinesz00zzsaw_jvm_inlinez00();
					}
			}
		}
	}



/* &backend-link-objects2148 */
	obj_t BGl_z62backendzd2linkzd2objects2148z62zzbackend_jvmz00(obj_t
		BgL_envz00_3528, obj_t BgL_mez00_3529, obj_t BgL_sourcesz00_3530)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 260 */
			{
				BgL_jvmz00_bglt BgL_mez00_1986;
				obj_t BgL_sourcesz00_1987;

				BgL_mez00_1986 = ((BgL_jvmz00_bglt) BgL_mez00_3529);
				BgL_sourcesz00_1987 = BgL_sourcesz00_3530;
				if (NULLP(BgL_sourcesz00_1987))
					{	/* BackEnd/jvm.scm 265 */
						obj_t BgL_firstz00_1992;

						BgL_firstz00_1992 =
							BGl_prefixz00zz__osz00(CAR
							(BGl_za2ozd2filesza2zd2zzengine_paramz00));
						{	/* BackEnd/jvm.scm 266 */
							obj_t BgL_list2286z00_1993;

							{	/* BackEnd/jvm.scm 266 */
								obj_t BgL_arg2287z00_1994;

								{	/* BackEnd/jvm.scm 266 */
									obj_t BgL_arg2288z00_1995;

									{	/* BackEnd/jvm.scm 266 */
										obj_t BgL_arg2289z00_1996;

										BgL_arg2289z00_1996 =
											MAKE_PAIR(BGl_za2ozd2filesza2zd2zzengine_paramz00, BNIL);
										BgL_arg2288z00_1995 =
											MAKE_PAIR(BGl_string2570z00zzbackend_jvmz00,
											BgL_arg2289z00_1996);
									}
									BgL_arg2287z00_1994 =
										MAKE_PAIR(BGl_string2571z00zzbackend_jvmz00,
										BgL_arg2288z00_1995);
								}
								BgL_list2286z00_1993 =
									MAKE_PAIR(BGl_string2572z00zzbackend_jvmz00,
									BgL_arg2287z00_1994);
							}
							BGl_warningz00zz__errorz00(BgL_list2286z00_1993);
						}
						BGl_loadzd2libraryzd2initz00zzmodule_alibraryz00();
						BGl_readzd2jfilezd2zzread_jvmz00();
						return BGl_jvmzd2ldzd2zzsaw_jvm_ldz00(BFALSE);
					}
				else
					{
						obj_t BgL_sourcesz00_2001;
						obj_t BgL_clsz00_2002;
						obj_t BgL_mainzd2modulezd2_2003;
						obj_t BgL_mainz00_2004;
						obj_t BgL_fmainz00_2005;
						obj_t BgL_librariesz00_2006;

						BgL_sourcesz00_2001 = BgL_sourcesz00_1987;
						BgL_clsz00_2002 = BNIL;
						BgL_mainzd2modulezd2_2003 = BFALSE;
						BgL_mainz00_2004 = BFALSE;
						BgL_fmainz00_2005 = BGl_string2545z00zzbackend_jvmz00;
						BgL_librariesz00_2006 = BNIL;
					BgL_zc3anonymousza32291ze3z83_2007:
						if (NULLP(BgL_sourcesz00_2001))
							{	/* BackEnd/jvm.scm 277 */
								if (CBOOL(BgL_mainz00_2004))
									{	/* BackEnd/jvm.scm 281 */
										obj_t BgL_firstz00_2009;

										BgL_firstz00_2009 =
											BGl_prefixz00zz__osz00(CAR
											(BGl_za2ozd2filesza2zd2zzengine_paramz00));
										{
											obj_t BgL_l2139z00_2011;

											BgL_l2139z00_2011 = BgL_librariesz00_2006;
										BgL_zc3anonymousza32293ze3z83_2012:
											if (PAIRP(BgL_l2139z00_2011))
												{	/* BackEnd/jvm.scm 284 */
													{	/* BackEnd/jvm.scm 285 */
														obj_t BgL_libz00_2014;

														BgL_libz00_2014 = CAR(BgL_l2139z00_2011);
														{
															obj_t BgL_libsz00_2015;

															if (PAIRP(BgL_libz00_2014))
																{	/* BackEnd/jvm.scm 285 */
																	if (
																		(CAR(BgL_libz00_2014) ==
																			CNST_TABLE_REF(((long) 13))))
																		{	/* BackEnd/jvm.scm 285 */
																			BgL_libsz00_2015 = CDR(BgL_libz00_2014);
																			{
																				obj_t BgL_l2137z00_2023;

																				BgL_l2137z00_2023 = BgL_libsz00_2015;
																			BgL_zc3anonymousza32299ze3z83_2024:
																				if (PAIRP(BgL_l2137z00_2023))
																					{	/* BackEnd/jvm.scm 287 */
																						BGl_usezd2libraryz12zc0zzmodule_alibraryz00
																							(CAR(BgL_l2137z00_2023));
																						{
																							obj_t BgL_l2137z00_3917;

																							BgL_l2137z00_3917 =
																								CDR(BgL_l2137z00_2023);
																							BgL_l2137z00_2023 =
																								BgL_l2137z00_3917;
																							goto
																								BgL_zc3anonymousza32299ze3z83_2024;
																						}
																					}
																				else
																					{	/* BackEnd/jvm.scm 287 */
																						((bool_t) 1);
																					}
																			}
																		}
																	else
																		{	/* BackEnd/jvm.scm 285 */
																			((bool_t) 0);
																		}
																}
															else
																{	/* BackEnd/jvm.scm 285 */
																	((bool_t) 0);
																}
														}
													}
													{
														obj_t BgL_l2139z00_3920;

														BgL_l2139z00_3920 = CDR(BgL_l2139z00_2011);
														BgL_l2139z00_2011 = BgL_l2139z00_3920;
														goto BgL_zc3anonymousza32293ze3z83_2012;
													}
												}
											else
												{	/* BackEnd/jvm.scm 284 */
													((bool_t) 1);
												}
										}
										BGl_loadzd2libraryzd2initz00zzmodule_alibraryz00();
										{	/* BackEnd/jvm.scm 291 */
											obj_t BgL_list2304z00_2031;

											BgL_list2304z00_2031 = MAKE_PAIR(BgL_fmainz00_2005, BNIL);
											BGl_za2srczd2filesza2zd2zzengine_paramz00 =
												BgL_list2304z00_2031;
										}
										BGl_readzd2jfilezd2zzread_jvmz00();
										return
											BGl_jvmzd2ldzd2zzsaw_jvm_ldz00(BgL_mainzd2modulezd2_2003);
									}
								else
									{	/* BackEnd/jvm.scm 294 */
										obj_t BgL_tmpz00_2033;

										BgL_tmpz00_2033 =
											BGl_makezd2tmpzd2filezd2namezd2zzbackend_jvmz00();
										BGl_makezd2tmpzd2mainz00zzengine_linkz00(BgL_tmpz00_2033,
											CBOOL(BgL_mainz00_2004),
											string_to_symbol(BSTRING_TO_STRING
												(BGl_string2556z00zzbackend_jvmz00)), BgL_clsz00_2002,
											BgL_librariesz00_2006);
										{	/* BackEnd/jvm.scm 296 */
											obj_t BgL_list2307z00_2035;

											BgL_list2307z00_2035 = MAKE_PAIR(BgL_tmpz00_2033, BNIL);
											BGl_za2srczd2filesza2zd2zzengine_paramz00 =
												BgL_list2307z00_2035;
										}
										{
											obj_t BgL_raz00_2038;
											obj_t BgL_resz00_2039;

											BgL_raz00_2038 =
												BGl_za2restzd2argsza2zd2zzengine_paramz00;
											BgL_resz00_2039 = BNIL;
										BgL_zc3anonymousza32308ze3z83_2040:
											if (NULLP(BgL_raz00_2038))
												{	/* BackEnd/jvm.scm 302 */
													BGl_za2restzd2argsza2zd2zzengine_paramz00 =
														bgl_reverse_bang(BgL_resz00_2039);
												}
											else
												{	/* BackEnd/jvm.scm 304 */
													bool_t BgL_testz00_3935;

													{	/* BackEnd/jvm.scm 304 */
														obj_t BgL_arg2315z00_2047;

														BgL_arg2315z00_2047 =
															BGl_suffixz00zz__osz00(CAR(BgL_raz00_2038));
														BgL_testz00_3935 =
															CBOOL(BGl_memberz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg2315z00_2047,
																BGl_za2mcozd2suffixza2zd2zzengine_paramz00));
													}
													if (BgL_testz00_3935)
														{
															obj_t BgL_raz00_3940;

															BgL_raz00_3940 = CDR(BgL_raz00_2038);
															BgL_raz00_2038 = BgL_raz00_3940;
															goto BgL_zc3anonymousza32308ze3z83_2040;
														}
													else
														{	/* BackEnd/jvm.scm 307 */
															obj_t BgL_arg2312z00_2044;
															obj_t BgL_arg2313z00_2045;

															BgL_arg2312z00_2044 = CDR(BgL_raz00_2038);
															BgL_arg2313z00_2045 =
																MAKE_PAIR(CAR(BgL_raz00_2038), BgL_resz00_2039);
															{
																obj_t BgL_resz00_3946;
																obj_t BgL_raz00_3945;

																BgL_raz00_3945 = BgL_arg2312z00_2044;
																BgL_resz00_3946 = BgL_arg2313z00_2045;
																BgL_resz00_2039 = BgL_resz00_3946;
																BgL_raz00_2038 = BgL_raz00_3945;
																goto BgL_zc3anonymousza32308ze3z83_2040;
															}
														}
												}
										}
										{	/* BackEnd/jvm.scm 308 */
											obj_t BgL_val1135z00_2050;

											BgL_val1135z00_2050 =
												BGl_zc3exitza32322ze3z83zzbackend_jvmz00();
											BGl_loadzd2libraryzd2initz00zzmodule_alibraryz00();
											{	/* BackEnd/jvm.scm 312 */
												obj_t BgL_prez00_2051;

												BgL_prez00_2051 =
													BGl_prefixz00zz__osz00(BgL_tmpz00_2033);
												{	/* BackEnd/jvm.scm 312 */
													obj_t BgL_classzd2filezd2_2052;

													BgL_classzd2filezd2_2052 =
														string_append(BgL_prez00_2051,
														BGl_string2553z00zzbackend_jvmz00);
													{	/* BackEnd/jvm.scm 313 */

														if (fexists(BSTRING_TO_STRING(BgL_tmpz00_2033)))
															{	/* BackEnd/jvm.scm 315 */
																char *BgL_stringz00_3410;

																BgL_stringz00_3410 =
																	BSTRING_TO_STRING(BgL_tmpz00_2033);
																if (unlink(BgL_stringz00_3410))
																	{	/* Ieee/port.scm 1345 */
																		((bool_t) 0);
																	}
																else
																	{	/* Ieee/port.scm 1345 */
																		((bool_t) 1);
																	}
															}
														else
															{	/* BackEnd/jvm.scm 314 */
																((bool_t) 0);
															}
													}
												}
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1135z00_2050)))
												{	/* BackEnd/jvm.scm 312 */
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1135z00_2050), CDR(BgL_val1135z00_2050));
												}
											else
												{	/* BackEnd/jvm.scm 312 */
													BgL_val1135z00_2050;
												}
										}
										return BINT(((long) 0));
							}}
						else
							{	/* BackEnd/jvm.scm 317 */
								obj_t BgL_portz00_2060;

								{	/* BackEnd/jvm.scm 317 */
									obj_t BgL_arg2392z00_2141;

									{	/* BackEnd/jvm.scm 317 */
										obj_t BgL_pairz00_3414;

										BgL_pairz00_3414 = BgL_sourcesz00_2001;
										BgL_arg2392z00_2141 = CAR(CAR(BgL_pairz00_3414));
									}
									{	/* BackEnd/jvm.scm 317 */

										BgL_portz00_2060 =
											BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00
											(BgL_arg2392z00_2141, BTRUE, BINT(((long) 5000000)));
								}}
								if (INPUT_PORTP(BgL_portz00_2060))
									{	/* BackEnd/jvm.scm 320 */
										obj_t BgL_expz00_2062;

										{	/* BackEnd/jvm.scm 320 */
											obj_t BgL_list2389z00_2139;

											BgL_list2389z00_2139 = MAKE_PAIR(BgL_portz00_2060, BNIL);
											BgL_expz00_2062 =
												BGl_compilerzd2readzd2zzread_readerz00
												(BgL_list2389z00_2139);
										}
										bgl_close_input_port(BgL_portz00_2060);
										{
											obj_t BgL_namez00_2063;
											obj_t BgL_newzd2mainzd2_2064;
											obj_t BgL_namez00_2066;

											if (PAIRP(BgL_expz00_2062))
												{	/* BackEnd/jvm.scm 322 */
													obj_t BgL_cdrzd2166zd2_2071;

													BgL_cdrzd2166zd2_2071 = CDR(BgL_expz00_2062);
													if (
														(CAR(BgL_expz00_2062) ==
															CNST_TABLE_REF(((long) 14))))
														{	/* BackEnd/jvm.scm 322 */
															if (PAIRP(BgL_cdrzd2166zd2_2071))
																{
																	obj_t BgL_gzd2173zd2_2076;

																	BgL_gzd2173zd2_2076 =
																		CDR(BgL_cdrzd2166zd2_2071);
																BgL_zc3anonymousza32328ze3z83_2077:
																	if (PAIRP(BgL_gzd2173zd2_2076))
																		{	/* BackEnd/jvm.scm 322 */
																			obj_t BgL_carzd2176zd2_2079;

																			BgL_carzd2176zd2_2079 =
																				CAR(BgL_gzd2173zd2_2076);
																			if (PAIRP(BgL_carzd2176zd2_2079))
																				{	/* BackEnd/jvm.scm 322 */
																					obj_t BgL_cdrzd2180zd2_2081;

																					BgL_cdrzd2180zd2_2081 =
																						CDR(BgL_carzd2176zd2_2079);
																					if (
																						(CAR(BgL_carzd2176zd2_2079) ==
																							CNST_TABLE_REF(((long) 15))))
																						{	/* BackEnd/jvm.scm 322 */
																							if (PAIRP(BgL_cdrzd2180zd2_2081))
																								{	/* BackEnd/jvm.scm 322 */
																									if (NULLP(CDR
																											(BgL_cdrzd2180zd2_2081)))
																										{	/* BackEnd/jvm.scm 322 */
																											BgL_namez00_2063 =
																												CAR
																												(BgL_cdrzd2166zd2_2071);
																											BgL_newzd2mainzd2_2064 =
																												CAR
																												(BgL_cdrzd2180zd2_2081);
																											{	/* BackEnd/jvm.scm 327 */
																												obj_t
																													BgL_arg2345z00_2097;
																												{	/* BackEnd/jvm.scm 327 */
																													obj_t
																														BgL_arg2347z00_2099;
																													obj_t
																														BgL_arg2348z00_2100;
																													{	/* BackEnd/jvm.scm 327 */
																														obj_t
																															BgL_arg2349z00_2101;
																														{	/* BackEnd/jvm.scm 327 */
																															obj_t
																																BgL_arg2350z00_2102;
																															{	/* BackEnd/jvm.scm 327 */
																																obj_t
																																	BgL_pairz00_3420;
																																BgL_pairz00_3420
																																	=
																																	BgL_sourcesz00_2001;
																																BgL_arg2350z00_2102
																																	=
																																	CDR(CAR
																																	(BgL_pairz00_3420));
																															}
																															BgL_arg2349z00_2101
																																=
																																BGl_prefixz00zz__osz00
																																(BgL_arg2350z00_2102);
																														}
																														BgL_arg2347z00_2099
																															=
																															BGl_jvmzd2classzd2sanszd2directoryzd2zzread_jvmz00
																															(BgL_arg2349z00_2101);
																													}
																													BgL_arg2348z00_2100 =
																														BGl_filezd2separatorzd2zz__osz00
																														();
																													BgL_arg2345z00_2097 =
																														BGl_stringzd2replacezd2zz__r4_strings_6_7z00
																														(BgL_arg2347z00_2099,
																														CCHAR
																														(BgL_arg2348z00_2100),
																														(char) (((unsigned
																																	char) '.')));
																												}
																												BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
																													(BgL_namez00_2063,
																													BgL_arg2345z00_2097,
																													BNIL);
																											}
																											if (CBOOL
																												(BgL_mainz00_2004))
																												{	/* BackEnd/jvm.scm 336 */
																													obj_t
																														BgL_arg2352z00_2103;
																													obj_t
																														BgL_arg2353z00_2104;
																													{	/* BackEnd/jvm.scm 336 */
																														obj_t
																															BgL_arg2354z00_2105;
																														{	/* BackEnd/jvm.scm 336 */
																															obj_t
																																BgL_pairz00_3424;
																															BgL_pairz00_3424 =
																																BgL_sourcesz00_2001;
																															BgL_arg2354z00_2105
																																=
																																CAR(CAR
																																(BgL_pairz00_3424));
																														}
																														{	/* BackEnd/jvm.scm 332 */
																															obj_t
																																BgL_list2355z00_2106;
																															{	/* BackEnd/jvm.scm 332 */
																																obj_t
																																	BgL_arg2356z00_2107;
																																{	/* BackEnd/jvm.scm 332 */
																																	obj_t
																																		BgL_arg2358z00_2108;
																																	{	/* BackEnd/jvm.scm 332 */
																																		obj_t
																																			BgL_arg2359z00_2109;
																																		{	/* BackEnd/jvm.scm 332 */
																																			obj_t
																																				BgL_arg2360z00_2110;
																																			BgL_arg2360z00_2110
																																				=
																																				MAKE_PAIR
																																				(BGl_string2574z00zzbackend_jvmz00,
																																				BNIL);
																																			BgL_arg2359z00_2109
																																				=
																																				MAKE_PAIR
																																				(BgL_arg2354z00_2105,
																																				BgL_arg2360z00_2110);
																																		}
																																		BgL_arg2358z00_2108
																																			=
																																			MAKE_PAIR
																																			(BGl_string2575z00zzbackend_jvmz00,
																																			BgL_arg2359z00_2109);
																																	}
																																	BgL_arg2356z00_2107
																																		=
																																		MAKE_PAIR
																																		(BgL_fmainz00_2005,
																																		BgL_arg2358z00_2108);
																																}
																																BgL_list2355z00_2106
																																	=
																																	MAKE_PAIR
																																	(BGl_string2576z00zzbackend_jvmz00,
																																	BgL_arg2356z00_2107);
																															}
																															BgL_arg2352z00_2103
																																=
																																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																																(BgL_list2355z00_2106);
																														}
																													}
																													BgL_arg2353z00_2104 =
																														MAKE_PAIR
																														(BgL_mainz00_2004,
																														BgL_newzd2mainzd2_2064);
																													BGl_errorz00zz__errorz00
																														(BGl_string2545z00zzbackend_jvmz00,
																														BgL_arg2352z00_2103,
																														BgL_arg2353z00_2104);
																												}
																											else
																												{	/* BackEnd/jvm.scm 330 */
																													BFALSE;
																												}
																											{	/* BackEnd/jvm.scm 338 */
																												obj_t
																													BgL_arg2361z00_2111;
																												obj_t
																													BgL_arg2362z00_2112;
																												obj_t
																													BgL_arg2363z00_2113;
																												obj_t
																													BgL_arg2364z00_2114;
																												BgL_arg2361z00_2111 =
																													CDR
																													(BgL_sourcesz00_2001);
																												{	/* BackEnd/jvm.scm 341 */
																													obj_t
																														BgL_arg2365z00_2115;
																													{	/* BackEnd/jvm.scm 341 */
																														obj_t
																															BgL_arg2366z00_2116;
																														{	/* BackEnd/jvm.scm 341 */
																															obj_t
																																BgL_arg2369z00_2119;
																															{	/* BackEnd/jvm.scm 341 */
																																obj_t
																																	BgL_pairz00_3429;
																																BgL_pairz00_3429
																																	=
																																	BgL_sourcesz00_2001;
																																BgL_arg2369z00_2119
																																	=
																																	CAR(CAR
																																	(BgL_pairz00_3429));
																															}
																															BgL_arg2366z00_2116
																																=
																																string_append_3
																																(BGl_string2573z00zzbackend_jvmz00,
																																BgL_arg2369z00_2119,
																																BGl_string2573z00zzbackend_jvmz00);
																														}
																														{	/* BackEnd/jvm.scm 339 */
																															obj_t
																																BgL_list2367z00_2117;
																															{	/* BackEnd/jvm.scm 339 */
																																obj_t
																																	BgL_arg2368z00_2118;
																																BgL_arg2368z00_2118
																																	=
																																	MAKE_PAIR
																																	(BgL_arg2366z00_2116,
																																	BNIL);
																																BgL_list2367z00_2117
																																	=
																																	MAKE_PAIR
																																	(BgL_namez00_2063,
																																	BgL_arg2368z00_2118);
																															}
																															BgL_arg2365z00_2115
																																=
																																BgL_list2367z00_2117;
																														}
																													}
																													BgL_arg2362z00_2112 =
																														MAKE_PAIR
																														(BgL_arg2365z00_2115,
																														BgL_clsz00_2002);
																												}
																												{	/* BackEnd/jvm.scm 345 */
																													obj_t
																														BgL_pairz00_3435;
																													BgL_pairz00_3435 =
																														BgL_sourcesz00_2001;
																													BgL_arg2363z00_2113 =
																														CAR(CAR
																														(BgL_pairz00_3435));
																												}
																												{	/* BackEnd/jvm.scm 346 */
																													obj_t
																														BgL_arg2370z00_2120;
																													{	/* BackEnd/jvm.scm 346 */
																														obj_t
																															BgL_arg2371z00_2121;
																														{	/* BackEnd/jvm.scm 346 */
																															obj_t
																																BgL_pairz00_3439;
																															BgL_pairz00_3439 =
																																BgL_expz00_2062;
																															BgL_arg2371z00_2121
																																=
																																CDR(CDR
																																(BgL_pairz00_3439));
																														}
																														BgL_arg2370z00_2120
																															=
																															BGl_findzd2librarieszd2zzengine_linkz00
																															(BgL_arg2371z00_2121);
																													}
																													BgL_arg2364z00_2114 =
																														BGl_appendzd221011zd2zzbackend_jvmz00
																														(BgL_arg2370z00_2120,
																														BgL_librariesz00_2006);
																												}
																												{
																													obj_t
																														BgL_librariesz00_4036;
																													obj_t
																														BgL_fmainz00_4035;
																													obj_t
																														BgL_mainz00_4034;
																													obj_t
																														BgL_mainzd2modulezd2_4033;
																													obj_t BgL_clsz00_4032;
																													obj_t
																														BgL_sourcesz00_4031;
																													BgL_sourcesz00_4031 =
																														BgL_arg2361z00_2111;
																													BgL_clsz00_4032 =
																														BgL_arg2362z00_2112;
																													BgL_mainzd2modulezd2_4033
																														= BgL_namez00_2063;
																													BgL_mainz00_4034 =
																														BgL_newzd2mainzd2_2064;
																													BgL_fmainz00_4035 =
																														BgL_arg2363z00_2113;
																													BgL_librariesz00_4036
																														=
																														BgL_arg2364z00_2114;
																													BgL_librariesz00_2006
																														=
																														BgL_librariesz00_4036;
																													BgL_fmainz00_2005 =
																														BgL_fmainz00_4035;
																													BgL_mainz00_2004 =
																														BgL_mainz00_4034;
																													BgL_mainzd2modulezd2_2003
																														=
																														BgL_mainzd2modulezd2_4033;
																													BgL_clsz00_2002 =
																														BgL_clsz00_4032;
																													BgL_sourcesz00_2001 =
																														BgL_sourcesz00_4031;
																													goto
																														BgL_zc3anonymousza32291ze3z83_2007;
																												}
																											}
																										}
																									else
																										{
																											obj_t BgL_gzd2173zd2_4039;

																											BgL_gzd2173zd2_4039 =
																												CDR
																												(BgL_gzd2173zd2_2076);
																											BgL_gzd2173zd2_2076 =
																												BgL_gzd2173zd2_4039;
																											goto
																												BgL_zc3anonymousza32328ze3z83_2077;
																										}
																								}
																							else
																								{
																									obj_t BgL_gzd2173zd2_4041;

																									BgL_gzd2173zd2_4041 =
																										CDR(BgL_gzd2173zd2_2076);
																									BgL_gzd2173zd2_2076 =
																										BgL_gzd2173zd2_4041;
																									goto
																										BgL_zc3anonymousza32328ze3z83_2077;
																								}
																						}
																					else
																						{
																							obj_t BgL_gzd2173zd2_4043;

																							BgL_gzd2173zd2_4043 =
																								CDR(BgL_gzd2173zd2_2076);
																							BgL_gzd2173zd2_2076 =
																								BgL_gzd2173zd2_4043;
																							goto
																								BgL_zc3anonymousza32328ze3z83_2077;
																						}
																				}
																			else
																				{
																					obj_t BgL_gzd2173zd2_4045;

																					BgL_gzd2173zd2_4045 =
																						CDR(BgL_gzd2173zd2_2076);
																					BgL_gzd2173zd2_2076 =
																						BgL_gzd2173zd2_4045;
																					goto
																						BgL_zc3anonymousza32328ze3z83_2077;
																				}
																		}
																	else
																		{	/* BackEnd/jvm.scm 322 */
																			BgL_namez00_2066 =
																				CAR(CDR(BgL_expz00_2062));
																			{	/* BackEnd/jvm.scm 352 */
																				obj_t BgL_arg2372z00_2122;

																				{	/* BackEnd/jvm.scm 352 */
																					obj_t BgL_arg2374z00_2124;
																					obj_t BgL_arg2375z00_2125;

																					{	/* BackEnd/jvm.scm 352 */
																						obj_t BgL_arg2376z00_2126;

																						{	/* BackEnd/jvm.scm 352 */
																							obj_t BgL_arg2377z00_2127;

																							{	/* BackEnd/jvm.scm 352 */
																								obj_t BgL_pairz00_3443;

																								BgL_pairz00_3443 =
																									BgL_sourcesz00_2001;
																								BgL_arg2377z00_2127 =
																									CDR(CAR(BgL_pairz00_3443));
																							}
																							BgL_arg2376z00_2126 =
																								BGl_prefixz00zz__osz00
																								(BgL_arg2377z00_2127);
																						}
																						BgL_arg2374z00_2124 =
																							BGl_jvmzd2classzd2sanszd2directoryzd2zzread_jvmz00
																							(BgL_arg2376z00_2126);
																					}
																					BgL_arg2375z00_2125 =
																						BGl_filezd2separatorzd2zz__osz00();
																					BgL_arg2372z00_2122 =
																						BGl_stringzd2replacezd2zz__r4_strings_6_7z00
																						(BgL_arg2374z00_2124,
																						CCHAR(BgL_arg2375z00_2125),
																						(char) (((unsigned char) '.')));
																				}
																				BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
																					(BgL_namez00_2066,
																					BgL_arg2372z00_2122, BNIL);
																			}
																			{	/* BackEnd/jvm.scm 355 */
																				obj_t BgL_arg2378z00_2128;
																				obj_t BgL_arg2379z00_2129;
																				obj_t BgL_arg2380z00_2130;

																				BgL_arg2378z00_2128 =
																					CDR(BgL_sourcesz00_2001);
																				{	/* BackEnd/jvm.scm 358 */
																					obj_t BgL_arg2381z00_2131;

																					{	/* BackEnd/jvm.scm 358 */
																						obj_t BgL_arg2382z00_2132;

																						{	/* BackEnd/jvm.scm 358 */
																							obj_t BgL_arg2385z00_2135;

																							{	/* BackEnd/jvm.scm 358 */
																								obj_t BgL_pairz00_3448;

																								BgL_pairz00_3448 =
																									BgL_sourcesz00_2001;
																								BgL_arg2385z00_2135 =
																									CAR(CAR(BgL_pairz00_3448));
																							}
																							BgL_arg2382z00_2132 =
																								string_append_3
																								(BGl_string2573z00zzbackend_jvmz00,
																								BgL_arg2385z00_2135,
																								BGl_string2573z00zzbackend_jvmz00);
																						}
																						{	/* BackEnd/jvm.scm 356 */
																							obj_t BgL_list2383z00_2133;

																							{	/* BackEnd/jvm.scm 356 */
																								obj_t BgL_arg2384z00_2134;

																								BgL_arg2384z00_2134 =
																									MAKE_PAIR(BgL_arg2382z00_2132,
																									BNIL);
																								BgL_list2383z00_2133 =
																									MAKE_PAIR(BgL_namez00_2066,
																									BgL_arg2384z00_2134);
																							}
																							BgL_arg2381z00_2131 =
																								BgL_list2383z00_2133;
																					}}
																					BgL_arg2379z00_2129 =
																						MAKE_PAIR(BgL_arg2381z00_2131,
																						BgL_clsz00_2002);
																				}
																				{	/* BackEnd/jvm.scm 363 */
																					obj_t BgL_arg2386z00_2136;

																					{	/* BackEnd/jvm.scm 363 */
																						obj_t BgL_arg2387z00_2137;

																						{	/* BackEnd/jvm.scm 363 */
																							obj_t BgL_pairz00_3454;

																							BgL_pairz00_3454 =
																								BgL_expz00_2062;
																							BgL_arg2387z00_2137 =
																								CDR(CDR(BgL_pairz00_3454));
																						}
																						BgL_arg2386z00_2136 =
																							BGl_findzd2librarieszd2zzengine_linkz00
																							(BgL_arg2387z00_2137);
																					}
																					BgL_arg2380z00_2130 =
																						BGl_appendzd221011zd2zzbackend_jvmz00
																						(BgL_arg2386z00_2136,
																						BgL_librariesz00_2006);
																				}
																				{
																					obj_t BgL_librariesz00_4069;
																					obj_t BgL_clsz00_4068;
																					obj_t BgL_sourcesz00_4067;

																					BgL_sourcesz00_4067 =
																						BgL_arg2378z00_2128;
																					BgL_clsz00_4068 = BgL_arg2379z00_2129;
																					BgL_librariesz00_4069 =
																						BgL_arg2380z00_2130;
																					BgL_librariesz00_2006 =
																						BgL_librariesz00_4069;
																					BgL_clsz00_2002 = BgL_clsz00_4068;
																					BgL_sourcesz00_2001 =
																						BgL_sourcesz00_4067;
																					goto
																						BgL_zc3anonymousza32291ze3z83_2007;
																				}
																			}
																		}
																}
															else
																{	/* BackEnd/jvm.scm 322 */
																BgL_tagzd2157zd2_2068:
																	{
																		obj_t BgL_sourcesz00_4073;

																		BgL_sourcesz00_4073 =
																			CDR(BgL_sourcesz00_2001);
																		BgL_sourcesz00_2001 = BgL_sourcesz00_4073;
																		goto BgL_zc3anonymousza32291ze3z83_2007;
																	}
																}
														}
													else
														{	/* BackEnd/jvm.scm 322 */
															goto BgL_tagzd2157zd2_2068;
														}
												}
											else
												{	/* BackEnd/jvm.scm 322 */
													goto BgL_tagzd2157zd2_2068;
												}
										}
									}
								else
									{	/* BackEnd/jvm.scm 319 */
										obj_t BgL_arg2391z00_2140;

										{	/* BackEnd/jvm.scm 319 */
											obj_t BgL_pairz00_3486;

											BgL_pairz00_3486 = BgL_sourcesz00_2001;
											BgL_arg2391z00_2140 = CAR(CAR(BgL_pairz00_3486));
										}
										return
											BGl_errorz00zz__errorz00
											(BGl_string2545z00zzbackend_jvmz00,
											BGl_string2577z00zzbackend_jvmz00, BgL_arg2391z00_2140);
									}
							}
					}
			}
		}
	}



/* <exit:2322> */
	obj_t BGl_zc3exitza32322ze3z83zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 311 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1136z00_2058;

			if (SET_EXIT(BgL_an_exit1136z00_2058))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1136z00_2058 = (void *) jmpbuf;
					{	/* BackEnd/jvm.scm 311 */

						PUSH_EXIT(BgL_an_exit1136z00_2058, ((long) 0));
						{	/* BackEnd/jvm.scm 309 */
							obj_t BgL_val1137z00_2059;

							BgL_val1137z00_2059 = BGl_compilerz00zzengine_compilerz00();
							POP_EXIT();
							return BgL_val1137z00_2059;
						}
					}
				}
		}
	}



/* &backend-cnst-table-n2146 */
	obj_t BGl_z62backendzd2cnstzd2tablezd2n2146zb0zzbackend_jvmz00(obj_t
		BgL_envz00_3531, obj_t BgL_mez00_3532, obj_t BgL_offsetz00_3533)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 236 */
			return BGl_string2578z00zzbackend_jvmz00;
		}
	}



/* &backend-link-jvm2144 */
	obj_t BGl_z62backendzd2linkzd2jvm2144z62zzbackend_jvmz00(obj_t
		BgL_envz00_3534, obj_t BgL_mez00_3535, obj_t BgL_resultz00_3536)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 229 */
			return BGl_jvmzd2ldzd2zzsaw_jvm_ldz00(BFALSE);
		}
	}



/* &backend-compile-jvm2142 */
	obj_t BGl_z62backendzd2compilezd2jvm2142z62zzbackend_jvmz00(obj_t
		BgL_envz00_3537, obj_t BgL_mez00_3538)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 64 */
			{
				BgL_jvmz00_bglt BgL_mez00_1859;

				BgL_mez00_1859 = ((BgL_jvmz00_bglt) BgL_mez00_3538);
				{	/* BackEnd/jvm.scm 66 */
					obj_t BgL_list2211z00_1863;

					{	/* BackEnd/jvm.scm 66 */
						obj_t BgL_arg2212z00_1864;

						{	/* BackEnd/jvm.scm 66 */
							obj_t BgL_arg2214z00_1865;

							BgL_arg2214z00_1865 =
								MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
							BgL_arg2212z00_1864 =
								MAKE_PAIR(BGl_string2579z00zzbackend_jvmz00,
								BgL_arg2214z00_1865);
						}
						BgL_list2211z00_1863 =
							MAKE_PAIR(BGl_string2580z00zzbackend_jvmz00, BgL_arg2212z00_1864);
					}
					BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
						BgL_list2211z00_1863);
				}
				BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
				BGl_za2currentzd2passza2zd2zzengine_passz00 =
					BGl_string2579z00zzbackend_jvmz00;
				{	/* BackEnd/jvm.scm 66 */
					obj_t BgL_g1111z00_1866;
					obj_t BgL_g1112z00_1867;

					{	/* BackEnd/jvm.scm 66 */
						obj_t BgL_list2223z00_1879;

						BgL_list2223z00_1879 =
							MAKE_PAIR(BGl_startzd2jvmzd2emissionz12zd2envzc0zzbackend_jvmz00,
							BNIL);
						BgL_g1111z00_1866 = BgL_list2223z00_1879;
					}
					BgL_g1112z00_1867 = CNST_TABLE_REF(((long) 16));
					{
						obj_t BgL_hooksz00_1869;
						obj_t BgL_hnamesz00_1870;

						BgL_hooksz00_1869 = BgL_g1111z00_1866;
						BgL_hnamesz00_1870 = BgL_g1112z00_1867;
					BgL_zc3anonymousza32215ze3z83_1871:
						if (NULLP(BgL_hooksz00_1869))
							{	/* BackEnd/jvm.scm 66 */
								CNST_TABLE_REF(((long) 17));
							}
						else
							{	/* BackEnd/jvm.scm 66 */
								bool_t BgL_testz00_4097;

								{	/* BackEnd/jvm.scm 66 */
									obj_t BgL_fun2222z00_1877;

									BgL_fun2222z00_1877 = CAR(BgL_hooksz00_1869);
									BgL_testz00_4097 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun2222z00_1877)
										(BgL_fun2222z00_1877, BEOA));
								}
								if (BgL_testz00_4097)
									{
										obj_t BgL_hnamesz00_4105;
										obj_t BgL_hooksz00_4103;

										BgL_hooksz00_4103 = CDR(BgL_hooksz00_1869);
										BgL_hnamesz00_4105 = CDR(BgL_hnamesz00_1870);
										BgL_hnamesz00_1870 = BgL_hnamesz00_4105;
										BgL_hooksz00_1869 = BgL_hooksz00_4103;
										goto BgL_zc3anonymousza32215ze3z83_1871;
									}
								else
									{	/* BackEnd/jvm.scm 66 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string2579z00zzbackend_jvmz00,
											BGl_string2581z00zzbackend_jvmz00,
											CAR(BgL_hnamesz00_1870));
									}
							}
					}
				}
				{	/* BackEnd/jvm.scm 68 */
					obj_t BgL_arg2225z00_1880;

					BgL_arg2225z00_1880 =
						BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
						(BGl_za2moduleza2z00zzmodule_modulez00);
					{	/* BackEnd/jvm.scm 67 */
						obj_t BgL_list2226z00_1881;

						{	/* BackEnd/jvm.scm 67 */
							obj_t BgL_arg2227z00_1882;

							{	/* BackEnd/jvm.scm 67 */
								obj_t BgL_arg2228z00_1883;

								{	/* BackEnd/jvm.scm 67 */
									obj_t BgL_arg2229z00_1884;

									{	/* BackEnd/jvm.scm 67 */
										obj_t BgL_arg2230z00_1885;

										{	/* BackEnd/jvm.scm 67 */
											obj_t BgL_arg2231z00_1886;

											BgL_arg2231z00_1886 =
												MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
											BgL_arg2230z00_1885 =
												MAKE_PAIR(BGl_string2582z00zzbackend_jvmz00,
												BgL_arg2231z00_1886);
										}
										BgL_arg2229z00_1884 =
											MAKE_PAIR(BgL_arg2225z00_1880, BgL_arg2230z00_1885);
									}
									BgL_arg2228z00_1883 =
										MAKE_PAIR(BGl_string2583z00zzbackend_jvmz00,
										BgL_arg2229z00_1884);
								}
								BgL_arg2227z00_1882 =
									MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00,
									BgL_arg2228z00_1883);
							}
							BgL_list2226z00_1881 =
								MAKE_PAIR(BGl_string2584z00zzbackend_jvmz00,
								BgL_arg2227z00_1882);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
							BgL_list2226z00_1881);
				}}
				{	/* BackEnd/jvm.scm 70 */
					obj_t BgL_arg2232z00_1887;

					{	/* BackEnd/jvm.scm 70 */
						obj_t BgL_arg2233z00_1888;

						BgL_arg2233z00_1888 =
							BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
							(BGl_za2moduleza2z00zzmodule_modulez00);
						BgL_arg2232z00_1887 =
							string_to_symbol(BSTRING_TO_STRING(BgL_arg2233z00_1888));
					}
					((((BgL_jvmz00_bglt) CREF(BgL_mez00_1859))->BgL_qnamez00) =
						((obj_t) BgL_arg2232z00_1887), BUNSPEC);
				}
				{	/* BackEnd/jvm.scm 73 */
					bool_t BgL_testz00_4123;

					if (CBOOL(BGl_za2mainza2z00zzmodule_modulez00))
						{	/* BackEnd/jvm.scm 73 */
							BgL_testz00_4123 = ((bool_t) 0);
						}
					else
						{	/* BackEnd/jvm.scm 73 */
							BgL_testz00_4123 =
								CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
								(BGl_za2passza2z00zzengine_paramz00,
									CNST_TABLE_REF(((long) 18))));
						}
					if (BgL_testz00_4123)
						{	/* BackEnd/jvm.scm 73 */
							BGl_za2mainza2z00zzmodule_modulez00 =
								BGl_makezd2bigloozd2mainz00zzbackend_c_mainz00();
						}
					else
						{	/* BackEnd/jvm.scm 73 */
							BFALSE;
						}
				}
				BGl_jvmzd2checkzd2packagez00zzbackend_jvmz00
					(BGl_za2moduleza2z00zzmodule_modulez00,
					BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00);
				{	/* BackEnd/jvm.scm 101 */
					obj_t BgL_lza2za2_1890;
					obj_t BgL_bnamez00_1891;

					BgL_lza2za2_1890 =
						BGl_saw_jvmzd2compilezd2zzsaw_jvm_compilez00(BgL_mez00_1859);
					if (
						(BGl_za2passza2z00zzengine_paramz00 == CNST_TABLE_REF(((long) 10))))
						{	/* BackEnd/jvm.scm 103 */
							if (PAIRP(BGl_za2srczd2filesza2zd2zzengine_paramz00))
								{	/* BackEnd/jvm.scm 104 */
									BgL_bnamez00_1891 =
										BGl_addsuffixz00zzbackend_jvmz00(BGl_prefixz00zz__osz00
										(BGl_basenamez00zz__osz00(CAR
												(BGl_za2srczd2filesza2zd2zzengine_paramz00))));
								}
							else
								{	/* BackEnd/jvm.scm 104 */
									BgL_bnamez00_1891 = BGl_string2585z00zzbackend_jvmz00;
								}
						}
					else
						{	/* BackEnd/jvm.scm 103 */
							if (STRINGP(BGl_za2destza2z00zzengine_paramz00))
								{	/* BackEnd/jvm.scm 107 */
									BgL_bnamez00_1891 =
										BGl_addsuffixz00zzbackend_jvmz00(BGl_prefixz00zz__osz00
										(BGl_basenamez00zz__osz00
											(BGl_za2destza2z00zzengine_paramz00)));
								}
							else
								{	/* BackEnd/jvm.scm 107 */
									if (PAIRP(BGl_za2srczd2filesza2zd2zzengine_paramz00))
										{	/* BackEnd/jvm.scm 108 */
											BgL_bnamez00_1891 =
												BGl_addsuffixz00zzbackend_jvmz00(BGl_prefixz00zz__osz00
												(BGl_basenamez00zz__osz00(CAR
														(BGl_za2srczd2filesza2zd2zzengine_paramz00))));
										}
									else
										{	/* BackEnd/jvm.scm 108 */
											BgL_bnamez00_1891 = BFALSE;
										}
								}
						}
					BGl_emitz00zzbackend_jvmz00(CAR(BgL_lza2za2_1890), BgL_bnamez00_1891);
					{	/* BackEnd/jvm.scm 114 */
						obj_t BgL_g2136z00_1893;

						BgL_g2136z00_1893 = CDR(BgL_lza2za2_1890);
						{
							obj_t BgL_l2134z00_1895;

							BgL_l2134z00_1895 = BgL_g2136z00_1893;
						BgL_zc3anonymousza32236ze3z83_1896:
							if (PAIRP(BgL_l2134z00_1895))
								{	/* BackEnd/jvm.scm 115 */
									{	/* BackEnd/jvm.scm 114 */
										obj_t BgL_cfz00_1898;

										BgL_cfz00_1898 = CAR(BgL_l2134z00_1895);
										BGl_emitz00zzbackend_jvmz00(BgL_cfz00_1898,
											BGl_jasnamez00zzbackend_jvmz00(BgL_cfz00_1898));
									}
									{
										obj_t BgL_l2134z00_4160;

										BgL_l2134z00_4160 = CDR(BgL_l2134z00_1895);
										BgL_l2134z00_1895 = BgL_l2134z00_4160;
										goto BgL_zc3anonymousza32236ze3z83_1896;
									}
								}
							else
								{	/* BackEnd/jvm.scm 115 */
									((bool_t) 1);
								}
						}
					}
					BGl_stopzd2onzd2passz00zzengine_passz00(CNST_TABLE_REF(((long) 19)),
						BGl_proc2586z00zzbackend_jvmz00);
					BGl_stopzd2onzd2passz00zzengine_passz00(CNST_TABLE_REF(((long) 8)),
						BGl_proc2587z00zzbackend_jvmz00);
					return BGl_stopzd2onzd2passz00zzengine_passz00(CNST_TABLE_REF(((long)
								7)), BGl_proc2588z00zzbackend_jvmz00);
		}}}
	}



/* <exit:2282> */
	obj_t BGl_zc3exitza32282ze3z83zzbackend_jvmz00(obj_t BgL_portz00_3566,
		obj_t BgL_classfilez00_3565)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 99 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1126z00_1968;

			if (SET_EXIT(BgL_an_exit1126z00_1968))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1126z00_1968 = (void *) jmpbuf;
					{	/* BackEnd/jvm.scm 99 */

						PUSH_EXIT(BgL_an_exit1126z00_1968, ((long) 0));
						{	/* BackEnd/jvm.scm 98 */
							obj_t BgL_val1127z00_1969;

							BgL_val1127z00_1969 =
								BGl_jvmzd2aszd2zzjas_asz00(BgL_classfilez00_3565,
								BgL_portz00_3566);
							POP_EXIT();
							return BgL_val1127z00_1969;
						}
					}
				}
		}
	}



/* <exit:2275> */
	obj_t BGl_zc3exitza32275ze3z83zzbackend_jvmz00(obj_t BgL_portz00_3571,
		obj_t BgL_ohs1113z00_3570, obj_t BgL_an_exitd1119z00_3569,
		obj_t BgL_res1115z00_3568, obj_t BgL_classfilez00_3567)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 93 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1123z00_1956;

			if (SET_EXIT(BgL_an_exit1123z00_1956))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1123z00_1956 = (void *) jmpbuf;
					{	/* BackEnd/jvm.scm 93 */

						PUSH_EXIT(BgL_an_exit1123z00_1956, ((long) 0));
						{	/* BackEnd/jvm.scm 93 */
							bool_t BgL_val1124z00_1957;

							{	/* BackEnd/jvm.scm 93 */
								obj_t BgL_arg2276z00_1958;

								{	/* BackEnd/jvm.scm 93 */
									obj_t BgL_zc3anonymousza32278ze3z83_3520;

									BgL_zc3anonymousza32278ze3z83_3520 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32278ze3ze1zzbackend_jvmz00,
										(int) (((long) 1)), (int) (((long) 2)));
									PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_3520,
										(int) (((long) 0)), BgL_res1115z00_3568);
									PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_3520,
										(int) (((long) 1)), BgL_an_exitd1119z00_3569);
									BgL_arg2276z00_1958 =
										MAKE_PAIR(BgL_zc3anonymousza32278ze3z83_3520,
										BgL_ohs1113z00_3570);
								}
								BGL_ERROR_HANDLER_SET(BgL_arg2276z00_1958);
								BUNSPEC;
							}
							{	/* BackEnd/jvm.scm 93 */
								obj_t BgL_auxz00_3539;

								{	/* BackEnd/jvm.scm 97 */
									obj_t BgL_val1125z00_1963;

									BgL_val1125z00_1963 =
										BGl_zc3exitza32282ze3z83zzbackend_jvmz00(BgL_portz00_3571,
										BgL_classfilez00_3567);
									close_binary_port(BgL_portz00_3571);
									if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
											(BgL_val1125z00_1963)))
										{	/* BackEnd/jvm.scm 99 */
											BgL_auxz00_3539 =
												BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
												(BgL_val1125z00_1963), CDR(BgL_val1125z00_1963));
										}
									else
										{	/* BackEnd/jvm.scm 99 */
											BgL_auxz00_3539 = BgL_val1125z00_1963;
										}
								}
								CELL_SET(BgL_res1115z00_3568, BgL_auxz00_3539);
							}
							BgL_val1124z00_1957 = ((bool_t) 0);
							POP_EXIT();
							return BBOOL(BgL_val1124z00_1957);
						}
					}
				}
		}
	}



/* <exit:2271> */
	obj_t BGl_zc3exitza32271ze3z83zzbackend_jvmz00(obj_t BgL_portz00_3574,
		obj_t BgL_res1115z00_3573, obj_t BgL_classfilez00_3572)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 93 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1118z00_1945;

			if (SET_EXIT(BgL_an_exit1118z00_1945))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1118z00_1945 = (void *) jmpbuf;
					{	/* BackEnd/jvm.scm 93 */

						PUSH_EXIT(BgL_an_exit1118z00_1945, ((long) 1));
						{	/* BackEnd/jvm.scm 93 */
							obj_t BgL_an_exitd1119z00_1946;

							BgL_an_exitd1119z00_1946 = ((obj_t) (&exitd));
							{	/* BackEnd/jvm.scm 93 */
								obj_t BgL_res1121z00_1949;

								{	/* BackEnd/jvm.scm 93 */
									obj_t BgL_ohs1113z00_1950;

									BgL_ohs1113z00_1950 = BGL_ERROR_HANDLER_GET();
									{	/* BackEnd/jvm.scm 93 */
										obj_t BgL_val1122z00_1951;

										BgL_val1122z00_1951 =
											BGl_zc3exitza32275ze3z83zzbackend_jvmz00(BgL_portz00_3574,
											BgL_ohs1113z00_1950, BgL_an_exitd1119z00_1946,
											BgL_res1115z00_3573, BgL_classfilez00_3572);
										BGL_ERROR_HANDLER_SET(BgL_ohs1113z00_1950);
										BUNSPEC;
										if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
												(BgL_val1122z00_1951)))
											{	/* BackEnd/jvm.scm 93 */
												BgL_res1121z00_1949 =
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
													(BgL_val1122z00_1951), CDR(BgL_val1122z00_1951));
											}
										else
											{	/* BackEnd/jvm.scm 93 */
												BgL_res1121z00_1949 = BgL_val1122z00_1951;
											}
									}
								}
								POP_EXIT();
								return BgL_res1121z00_1949;
							}
						}
					}
				}
		}
	}



/* emit */
	obj_t BGl_emitz00zzbackend_jvmz00(obj_t BgL_classfilez00_1923,
		obj_t BgL_destz00_1924)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 99 */
			{	/* BackEnd/jvm.scm 77 */
				obj_t BgL_dirz00_1926;

				BgL_dirz00_1926 = BGl_za2jvmzd2dirzd2nameza2z00zzbackend_jvmz00;
				if ((BGl_za2passza2z00zzengine_paramz00 == CNST_TABLE_REF(((long) 8))))
					{	/* BackEnd/jvm.scm 79 */
						obj_t BgL_portz00_1928;

						if (STRINGP(BgL_destz00_1924))
							{	/* BackEnd/jvm.scm 82 */
								obj_t BgL_arg2265z00_1932;

								BgL_arg2265z00_1932 =
									string_append_3(BgL_dirz00_1926,
									BGl_string2589z00zzbackend_jvmz00, BgL_destz00_1924);
								{	/* BackEnd/jvm.scm 81 */

									BgL_portz00_1928 =
										BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00
										(BgL_arg2265z00_1932, BTRUE);
								}
							}
						else
							{	/* BackEnd/jvm.scm 80 */
								obj_t BgL_res2498z00_3327;

								{	/* Ieee/port.scm 585 */
									obj_t BgL_auxz00_4216;

									BgL_auxz00_4216 = BGL_CURRENT_DYNAMIC_ENV();
									BgL_res2498z00_3327 =
										BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_4216);
								}
								BgL_portz00_1928 = BgL_res2498z00_3327;
							}
						BGl_jvmasdumpz00zzbackend_jvmz00(BgL_classfilez00_1923,
							BgL_portz00_1928);
						{	/* BackEnd/jvm.scm 84 */
							bool_t BgL_testz00_4220;

							{	/* BackEnd/jvm.scm 84 */
								obj_t BgL_arg2263z00_1930;

								{	/* BackEnd/jvm.scm 84 */
									obj_t BgL_res2499z00_3329;

									{	/* Ieee/port.scm 585 */
										obj_t BgL_auxz00_4221;

										BgL_auxz00_4221 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2499z00_3329 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_4221);
									}
									BgL_arg2263z00_1930 = BgL_res2499z00_3329;
								}
								BgL_testz00_4220 = (BgL_portz00_1928 == BgL_arg2263z00_1930);
							}
							if (BgL_testz00_4220)
								{	/* BackEnd/jvm.scm 84 */
									return BFALSE;
								}
							else
								{	/* BackEnd/jvm.scm 84 */
									return bgl_close_output_port(BgL_portz00_1928);
								}
						}
					}
				else
					{	/* BackEnd/jvm.scm 86 */
						obj_t BgL_cnamez00_1935;

						if (STRINGP(BgL_destz00_1924))
							{	/* BackEnd/jvm.scm 86 */
								BgL_cnamez00_1935 =
									string_append_3(BgL_dirz00_1926,
									BGl_string2589z00zzbackend_jvmz00, BgL_destz00_1924);
							}
						else
							{	/* BackEnd/jvm.scm 86 */
								BgL_cnamez00_1935 =
									string_append(BgL_dirz00_1926,
									BGl_string2590z00zzbackend_jvmz00);
							}
						{	/* BackEnd/jvm.scm 86 */
							obj_t BgL_portz00_1936;

							BgL_portz00_1936 =
								BGl_openzd2outputzd2binaryzd2filezd2zz__binaryz00
								(BgL_cnamez00_1935);
							{	/* BackEnd/jvm.scm 89 */

								{	/* BackEnd/jvm.scm 90 */
									obj_t BgL_list2266z00_1937;

									{	/* BackEnd/jvm.scm 90 */
										obj_t BgL_arg2267z00_1938;

										{	/* BackEnd/jvm.scm 90 */
											obj_t BgL_arg2268z00_1939;

											BgL_arg2268z00_1939 =
												MAKE_PAIR(BGl_string2591z00zzbackend_jvmz00, BNIL);
											BgL_arg2267z00_1938 =
												MAKE_PAIR(BgL_cnamez00_1935, BgL_arg2268z00_1939);
										}
										BgL_list2266z00_1937 =
											MAKE_PAIR(BGl_string2592z00zzbackend_jvmz00,
											BgL_arg2267z00_1938);
									}
									BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
										BgL_list2266z00_1937);
								}
								if (BINARY_PORTP(BgL_portz00_1936))
									{	/* BackEnd/jvm.scm 91 */
										BFALSE;
									}
								else
									{	/* BackEnd/jvm.scm 91 */
										BGl_errorz00zz__errorz00(BGl_string2593z00zzbackend_jvmz00,
											BGl_string2594z00zzbackend_jvmz00, BgL_cnamez00_1935);
									}
								{	/* BackEnd/jvm.scm 93 */
									obj_t BgL_res1115z00_1941;

									BgL_res1115z00_1941 = MAKE_CELL(BUNSPEC);
									if (CBOOL(BGl_zc3exitza32271ze3z83zzbackend_jvmz00
											(BgL_portz00_1936, BgL_res1115z00_1941,
												BgL_classfilez00_1923)))
										{	/* BackEnd/jvm.scm 93 */
											obj_t BgL_ez00_3343;

											BgL_ez00_3343 = CELL_REF(BgL_res1115z00_1941);
											{	/* BackEnd/jvm.scm 95 */
												char *BgL_stringz00_3344;

												BgL_stringz00_3344 =
													BSTRING_TO_STRING(BgL_cnamez00_1935);
												if (unlink(BgL_stringz00_3344))
													{	/* Ieee/port.scm 1345 */
														((bool_t) 0);
													}
												else
													{	/* Ieee/port.scm 1345 */
														((bool_t) 1);
													}
											}
											return BGl_raisez00zz__errorz00(BgL_ez00_3343);
										}
									else
										{	/* BackEnd/jvm.scm 93 */
											return CELL_REF(BgL_res1115z00_1941);
										}
								}
							}
						}
					}
			}
		}
	}



/* &<anonymous:2247> */
	obj_t BGl_z62zc3anonymousza32247ze3ze1zzbackend_jvmz00(obj_t BgL_envz00_3540)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 118 */
			{

				return CNST_TABLE_REF(((long) 20));
		}}
	}



/* &<anonymous:2245> */
	obj_t BGl_z62zc3anonymousza32245ze3ze1zzbackend_jvmz00(obj_t BgL_envz00_3541)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 117 */
			{

				return CNST_TABLE_REF(((long) 20));
		}}
	}



/* &<anonymous:2243> */
	obj_t BGl_z62zc3anonymousza32243ze3ze1zzbackend_jvmz00(obj_t BgL_envz00_3542)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 116 */
			{

				return CNST_TABLE_REF(((long) 20));
		}}
	}



/* &<anonymous:2278> */
	obj_t BGl_z62zc3anonymousza32278ze3ze1zzbackend_jvmz00(obj_t BgL_envz00_3543,
		obj_t BgL_ez00_3546)
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 93 */
			{	/* BackEnd/jvm.scm 93 */
				obj_t BgL_res1115z00_3544;
				obj_t BgL_an_exitd1119z00_3545;

				BgL_res1115z00_3544 =
					PROCEDURE_REF(BgL_envz00_3543, (int) (((long) 0)));
				BgL_an_exitd1119z00_3545 =
					PROCEDURE_REF(BgL_envz00_3543, (int) (((long) 1)));
				{
					obj_t BgL_ez00_1960;

					BgL_ez00_1960 = BgL_ez00_3546;
					CELL_SET(BgL_res1115z00_3544, BgL_ez00_1960);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1119z00_3545,
						BTRUE);
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzbackend_jvmz00()
	{
		AN_OBJECT;
		{	/* BackEnd/jvm.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 462549608),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzengine_linkz00(((long) 74690554),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzengine_compilerz00(((long) 412406770),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 70882025),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzmodule_alibraryz00(((long) 316727058),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 189813582),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 481724379),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 57787772),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzbackend_bvmz00(((long) 336068337),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzbackend_jvm_classz00(((long) 0),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzbackend_c_mainz00(((long) 65542503),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzjas_asz00(((long) 476839586),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzjas_peepz00(((long) 121595967),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzsaw_jvm_compilez00(((long) 100353792),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzsaw_jvm_ldz00(((long) 14468792),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzsaw_jvm_inlinez00(((long) 252555369),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			BGl_modulezd2initializa7ationz75zzinit_setrcz00(((long) 32737986),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
			return
				BGl_modulezd2initializa7ationz75zzread_readerz00(((long) 95801752),
				BSTRING_TO_STRING(BGl_string2595z00zzbackend_jvmz00));
		}
	}

#ifdef __cplusplus
}
#endif
